C ///////////////////////////////////////////////////////////////      
	 SUBROUTINE SUBDEVFO(ST)
C ..........................................................Nov 2019
C Enter station site <ST> as formal parameter
C
C Move median calculation into separate subroutine SUBMED27.for -27 prec. days...............
C
C
C T.L.Gulyaeva .................................................

C WNmF2 index using foF2med from -27 prec. days
C Include logarithmic scale indices -4,-3,-2,-1,0,1,2,3
C
      DIMENSION IM(12),DX(0:23),DA(28,0:23),DEV(0:23),XMED(0:23)
	+,IWTEC(0:23),CC(27,0:23),IDEV(0:23),IMED(0:23)
	CHARACTER*128 INFILE1,INFILE2,OUTFILE1,OUTFILE2,OUTFILE3,indate
	+,TXT
	CHARACTER*4 AYEAR,CYEAR,CTIME,YEAR_pre
	CHARACTER*2 AYR,AMN,ADY,DY1,DY2,PYR,PMN,CMN,CDY,ST
	+,ADY_pre,AMN_pre
	CHARACTER(8) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*56 txt3,txt4,txt6
	CHARACTER*16 txt2,txt5
	CHARACTER*12 txt1w,txt1m,txt1d
	CHARACTER*13 STAT
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	COMMON /BCC1/CC,XMED
C-      COMMON /BL2/STAT,GLATK,GLONK,AYEAR,AMN,DY1,DY2
	COMMON /BL2/ STAT,GLATK,GLONK,DD,TTT,ZZ,R12 
C
C    Start:
C
	txt1w='WfoF2-index '
	txt1m='foF2med*10  '
	txt1d='log(Ne/NmF2)'
      txt2='Date of issue:  '
      txt3='YYMMDD|UT 0    1    2    3    4    5    6    7    8    9'
	txt4='   10   11   12   13   14   15   16   17   18   19   20 '
	txt5='  21   22   23  '  
      txt6='--------------------------------------------------------'
	      CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
	CYEAR=DD(1:4)
	CMN=DD(5:6)
	CDY=DD(7:8)
	CTIME=tt(1:4)
c
	indate='d:/web/graf/date'    !!! Tamara !!!!!!!	 !FEB2015
	open(10,file=indate)							   !FEB2015			
	read(10,799) AYEAR,AMN,DY2,YEAR_pre,AMN_pre,ADY_pre  !FEB2015 NEW FORMAT NUMBER = 799
	WRITE(*,798) AYEAR, AMN, DY2,YEAR_pre,AMN_pre,ADY_pre !FEB2015 NEW FORMAT NUMBER = 798
	close(unit=10)
  798	format(' YEAR, AMN, DY2 = ',A4,2(1X,A2),1X,A4,2(1X,A2))
  799	format(A4,2(1X,A2),1X,A4,2(1X,A2))				 !FEB2015 NEW COMMAND NUMBER = 799
C
	AYR=AYEAR(3:4)
C
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
	iyri=iyr
	pyr=AYR ! prec_year
	jyr_pre=iyr

	read(AMN,*) rmn
	IMN=int(rmn)   ! current mn
	imni=imn
	jmn_pre=imn
C
	if (iyr.lt.90) then
	iyyyy=2000+iyr
	              else
	iyyyy=1900+iyr
	endif
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
C
C preceding month:
C
	if (imn.gt.1) then
	jmn_pre=imn-1			 ! prec_mn
	else
	jmn_pre=12				 ! prec_mn
	jyr_pre=iyr-1			 ! prec_yr
	if (jyr_pre.lt.0) jyr_pre=100+jyr_pre ! 1998 or 1999
	call blet2(jyr_pre,PYR)  ! prec_yr
	endif
	call blet2(jmn_pre,PMN)   ! prec_mn
C
      DY1='01'
	read(DY1,*) rdy1		 !
	idy1=int(rdy1)
	read(DY2,*) rdy2
	idy2=int(rdy2)
C
C Start for station:
	write(*,*) st          ! ++
200	CONTINUE
C Start from 1st day of current month
C-	call blet0(stat,sout)
 
      infile1='d:\web\graf\dat1\YR\stYRMN.txt'	 ! prec. month  Tamara
	INFILE1(21:22)=st							 ! Tamara
	INFILE1(18:19)=pyr							 ! Tamara
	INFILE1(23:24)=pyr							 ! Tamara
	INFILE1(25:26)=pmn							 ! Tamara
	infile2=infile1                              ! current mn
	INFILE2(18:19)=ayr							 ! Tamara
	INFILE2(23:24)=ayr							 ! Tamara
	INFILE2(25:26)=amn							 ! Tamara

      outfile1='d:\web\graf\dat2\YR\stYRMNm.txt'	 ! cur. month Tamara
      OUTFILE1(21:22)=st							 ! Tamara
	outfile1(18:19)=AYR							 ! Tamara
	outfile1(23:24)=AYR							 ! Tamara
	outfile1(25:26)=AMN							 ! Tamara
	outfile2=outfile1  							 ! Tamara
	outfile2(16:16)='3'							 ! Tamara
	outfile2(27:27)='d'							 ! Tamara
	outfile3=outfile1  							 ! Tamara
	outfile3(16:16)='4'							 ! Tamara
	outfile3(27:27)='i'							 ! Tamara

1100	CONTINUE
C+++
C
	      DO I=1,28
                   DO K=0,23
	      DA(I,K)=0.
	 enddo
	      ENDDO
C
C  =======================================================================
C
  700 format(A128)
   12	FORMAT(3I2,2X,24(F3.1,2X))
      ncnt=0        ! count of days 1,2,...,27   
      if (idy1.ge.27) goto 230	  ! goto input of current month

C  1st input of preceding mon-data
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	nndy=im(jmn_pre)	  ! prec. mn
	nnd1=nndy-25
      OPEN(13,FILE=OUTFILE1)  !dat2/fmed
	OPEN(14,FILE=OUTFILE2)	!dat3/Dlog
	OPEN(15,FILE=OUTFILE3)	!dat4/W-index
C
      OPEN(12,FILE=INFILE1,action='READ')
	do jx=1,4
	read(12,700) TXT  ! 4 extra lines
	enddo
C
C  day-to-day input for prec mon
C
	DO 400 jdy_pre=nnd1,nndy  ! for all UT

C Reading TEC data from statyrmnt.txt file:
  59   READ (12,12,END=105,ERR=2) JYR,JMN,JDY,(DX(k),k=0,23)
	if ((jyr.eq.jyr_pre).and.(jmn.eq.jmn_pre).and.(jdy.ge.nnd1)) then
	goto 159
	                 else
	goto 59
	                 endif
 159	do iut=0,23
	da(28,iut)=dx(iut)
	enddo
C
C Move data day-by-day up so that last day of month nndy=>day_27:
	do j=2,28			  ! <day-by-day
	do k=0,23			  ! all UT
	da(j-1,k)=da(j,k) ! move data one day up  
	enddo				  ! all UT
	enddo				  ! all days
	ncnt=ncnt+1
  400	CONTINUE		  !<day-by-day
  105	close(unit=12)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C start cycle on day-to-day for current mon  ======================================
C
  230	continue
			OPEN(12,FILE=INFILE2)  ! current month
	do jx=1,4
	read(12,700) TXT  ! 4 extra lines
	enddo
		nndy=im(imn)	 ! end of current month
 	idy=0
C
  499	idy=idy+1	 ! day-by-day input for idy=nndy,...,idy2, current month
      lday=ndoy(iyr,imn,idy) ! function to define day-of-year
	if (idy.gt.idy2) then					  ! idy2???????????
	goto 108 ! end of day-to-day processing 
	endif
       if (idy.gt.nndy) then  !?????????????
 	idy=1
	imn=imn+1
	endif
	call blet2(idy,ADY)
	 READ (12,12,END=108,ERR=2) JYR,JMN,JDY,(DX(k),k=0,23)
	do k=0,23
	da(28,k)=dx(k)
	enddo
C Move data one day up: 	if(idy.lt.idy1)  
C
 	do j=2,28			  ! <day-by-day
	do k=0,23			  ! all UT
	da(j-1,k)=da(j,k) ! move data one day up 
	enddo				  ! all UT
	enddo				  !<day-by-day
	if (lday.ge.lday-28) ncnt=ncnt+1
		if (ncnt.lt.27) goto 499

C
32	format(A13,1X,A2,1X,A12,2X,'glat ='F5.1,1X,'glon ='F5.1)    !txt1='WTEC-index'
		if (idy.eq.1) then
 	write(*,32) stat,st,txt1m,glatk,glonk	! f-median
	write(13,32) stat,st,txt1m,glatk,glonk
C	WRITE(*,18) cyear,cmn,cdy,ctime
	WRITE(13,18) cyear,cmn,cdy,ctime
C		write(*,201) 
		write(13,201) 
C 	write(*,32) stat,st,txt1d,glatk,glonk  ! DEVlog
	write(14,32) stat,st,txt1d,glatk,glonk
C	WRITE(*,18) cyear,cmn,cdy,ctime
	WRITE(14,18) cyear,cmn,cdy,ctime
C		write(*,201) 
		write(14,201) 
C 	write(*,32) stat,st,txt1w,glatk,glonk  ! W-index
	write(15,32) stat,st,txt1w,glatk,glonk
C	WRITE(*,18) cyear,cmn,cdy,ctime
	WRITE(15,18) cyear,cmn,cdy,ctime
C		write(*,201) 
		write(15,201) 
	endif
   18	format('Date of issue: ',A4,'/',A2,'/',A2,' Time:',A4)
  201	format('YYMMDD|UT 0    1    2    3    4    5    6    7    8'
  	&'    9   10   11   12   13   14   15   16   17   18   19   20'
	&'   21   22   23'/'-------------------------------------------'
     &'-------------------------------------------------------------'
     &'------------------------')
c
 	do k=0,23
	iwtec(k)=0
	xmed(k)=0.
	dev(k)=0.
	enddo

C $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C 
  10	CONTINUE
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  CALCULATION OF MEDIAN
C  115   for -27 prec days median
      DO J=1,27
        DO M=0,23          ! Hour-to-hour cycle: variable <m>
        CC(J,M)=DA(j,M)
	ENDDO
	ENDDO
	CALL CMEDIAN27(27)
C
C WTEC index:
C
          DO M=0,23
      XMD=XMED(M)**2	       !NmF2 = foF2**2
	xpar=CC(27,M)**2	    !NmF2 = foF2**2
	devlog=0.
C
      call windex(xpar,xmd,devlog,iw)
C
	DEV(M)=devlog
        if (devlog.GT.0.) then
	 IDEV(M)=nint(DEVLOG*1000+0.5)  ! devlog-index
	if (idev(m).gt.9999) idev(m)=9999
	                else
	 IDEV(M)=nint(DEVLOG*1000-0.5)  ! devlog-index
	if (idev(m).le.-1000) idev(m)=-999
	endif
	if (devlog.eq.999.) then 
	idev(m)=999
	endif
C
	IWTEC(M)=iw
	IMED(m)=nint(xmed(m)*10.)
	     ENDDO
C
C	WRITE(*,158) ayr,amn,ady,(IMED(K),K=0,23)
	WRITE(13,158) ayr,amn,ady,(IMED(K),K=0,23)
C	WRITE(*,158) ayr,amn,ady,(IDEV(K),K=0,23)
	WRITE(14,158) ayr,amn,ady,(IDEV(K),K=0,23)
C	WRITE(*,158) ayr,amn,ady,(IWTEC(K),K=0,23)
	WRITE(15,158) ayr,amn,ady,(IWTEC(K),K=0,23)
 158  FORMAT(3A2,24(1X,I4))
C
C-----------------------------------
C
	 ncnt=26
      goto 499		  ! to the next day processing
C
c
    2 CONTINUE
	       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
	   	pause ' '
	goto 102
  108 close(unit=13)
      close(unit=14)
	close(unit=15)
  102	close(unit=12)
	RETURN              
	END
C-------------------------------------------------------------------
c VERIFICATION OF MEDIAN ================
      subroutine cmedian27(ndnr)
C Input file: CC(27,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(27,0:23),XME(0:23),X1(31),X2(31)
		COMMON /BCC1/CC,XME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
      IF (CD1.LT.XD1) THEN 
	XMD=X2(ND2)
	else
	XMD=(X2(ND1)+X2(ND2))/2.
	ENDIF
C 1000 IF (MM.eq.0) MD=0
C
 1020 XME(M)=XMD
 1030 CONTINUE
c
 1050 RETURN
      END
c-------------------------------------------------------------------
      subroutine windex(xpar,xmed,delog,iw)
C
C   Procedure to calculate the ionospheric weather W index
C
C   Input: xpar = NeF2  - instantaneous value of the F2 layer peak electron density 
C      or  xpar = TECi  - instantaneous value of GPS-derived total electron content
C    		 xmed = NmF2  - quiet reference (median) value of the F2 layer peak electron density
C      or	 xmed = TEC m - quiet reference (median) value of total electron content
C
C   Output: ionospheric weather W index characterizing ionospheric and plasmaspheric activity:
C           W = 0, +1 or -1 (quiet state)
C           W = +2 or -2 (moderate disturbance)
C           W = +3 or -3 (moderate storm)
C           W = +4 or -4 (intense storm)
C
C   Includes logarithmic scale indices -4,-3,-2,-1,0,1,2,3,4
C   according to thresholds of 
C           log10(xpar/xmed)=-0.999,-0.301,-0.155,-0.045,0,0.045,0.155,0.301,0.999  
C
C   Ref.Gulyaeva, T.L.,, I. Stanislwska, and M. Tomasik. Ionospheric weather: Cloning missed 
C       foF2 observations for derivation of variability index. Annales Geophysicae, 26, N.2, 
C       315-321, 2008.
C       Gulyaeva, T.L.,and I. Stanislwska, Derivation of a planetary ionospheric storm index. 
C       Annales Geophysicae, 26, N.9, 2645-2648, 2008 .
C
      DIMENSION TR(7)
	real xpar,xmed
	INTEGER IIN(7)
   		data IIN/-3,-2,-1,0,1,2,3/           ! ID-index
	data TR/-.301,-.155,-.045,0.0
	+,.045,.155,.301/
C  Temp:
    	 if (delog.ne.0.) goto 5   ! temp if delog is entered
	      delog=alog10(XPAR)-alog10(XMED)
   5		if (delog.gt.tr(7)) then
		iw=4
	goto 2
		endif 
		if (delog.eq.0.) then
			iw=0
	goto 2
	endif
	      if(delog.le.tr(1)) then
	iw=-4                 ! W-index
	goto 2
	endif
	if (delog.ge.tr(7)) then
	iw=4				  ! W-index
 	goto 2
	endif
C
	do 1 n=1,7
	if (delog.lt.0.) then
	if ((delog.ge.tr(n)).and.(delog.lt.tr(n+1))) then
	iw=iin(n)              ! W-index
	endif
	      else
	if ((delog.gt.tr(n-1)).and.(delog.le.tr(n))) then
	iw=iin(n)              ! W-index
	endif

	endif
   1	continue
C
   2  continue
C
	RETURN
	END
C
C
C ===============================================================
