C ///////////////////////////////////////////////////////////////      
	 SUBROUTINE SUBDEVFO5(ST)
C ..........................................................Nov 2019
C Enter station site <ST> as formal parameter
C
C Move median calculation into separate subroutine SUBMED27.for -27 prec. days...............
C
C
C T.L.Gulyaeva .................................................

C WNmF2 index using foF2med from -27 prec. days
C Include logarithmic scale indices -4,-3,-2,-1,0,1,2,3
C
      DIMENSION IM(12),DX(0:23),DA(28,0:23),DEV(0:23),XMED(0:23)
	+,IWTEC(0:23),CC(27,0:23),IDEV(0:23),IMED(0:23),LB3(34,4)
	+,ff2(31,0:23),LB2(0:12,10),LC(5)
     +,XREG(0:31,6),XLEV(0:24),LB1(0:90,5),IDEL(0:31,0:23)
     +,YY(0:24),rx(24),ry(24),resp(31,0:23) ! resp%=(foF2**2-fmed**2)/fmed**2
	CHARACTER*128 INFILE1,INFILE2,OUTFILE1,OUTFILE2,OUTFILE3,indate
	+,TXT,OUTFILE4,OUTFILE5
	CHARACTER*4 AYEAR,CYEAR,CTIME,YEAR_pre,TI(12)
	CHARACTER*2 AYR,AMN,ADY,DY1,DY2,PYR,PMN,CMN,CDY,ST
	+,ADY_pre,AMN_pre
	CHARACTER(8) DDD
      CHARACTER(10) TT
      CHARACTER(5) ZZZ
	CHARACTER*56 txt3,txt4,txt6
	CHARACTER*16 txt2,txt5
	CHARACTER*12 txt1w,txt1m,txt1d
	CHARACTER*13 STAT
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
      DATA TI/'JAN.','FEB.','MAR.','APR.','MAY ','JUN.','JUL.','AUG.'
	+,'SEP.','OCT.','NOV.','DEC.'/
	COMMON /BCC1/CC,XMED
C-      COMMON /BL2/STAT,GLATK,GLONK,AYEAR,AMN,DY1,DY2
	COMMON /BL2/ STAT,GLATK,GLONK,DDD,TTT,ZZZ,R12 
C
C    Start:
C
	txt1w='WfoF2-index '
	txt1m='foF2med*10  '
	txt1d='log(Ne/NmF2)'
      txt2='Date of issue:  '
      txt3='YYMMDD|UT 0    1    2    3    4    5    6    7    8    9'
	txt4='   10   11   12   13   14   15   16   17   18   19   20 '
	txt5='  21   22   23  '  
      txt6='--------------------------------------------------------'
	      CALL DATE_AND_TIME(DATE=DDD,TIME=TT,ZONE=ZZZ)
	CYEAR=DDD(1:4)
	CMN=DDD(5:6)
	CDY=DDD(7:8)
	CTIME=tt(1:4)
c
	indate='d:/web/graf/date'    !!! Tamara !!!!!!!	 !FEB2015
	open(10,file=indate)							   !FEB2015			
	read(10,799) AYEAR,AMN,DY2,YEAR_pre,AMN_pre,ADY_pre  !FEB2015 NEW FORMAT NUMBER = 799
	WRITE(*,798) AYEAR, AMN, DY2,YEAR_pre,AMN_pre,ADY_pre !FEB2015 NEW FORMAT NUMBER = 798
	close(unit=10)
  798	format(' YEAR, AMN, DY2 = ',A4,2(1X,A2),1X,A4,2(1X,A2))
  799	format(A4,2(1X,A2),1X,A4,2(1X,A2))				 !FEB2015 NEW COMMAND NUMBER = 799
C
	AYR=AYEAR(3:4)
C
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
	iyri=iyr
	pyr=AYR ! prec_year
	jyr_pre=iyr

	read(AMN,*) rmn
	IMN=int(rmn)   ! current mn
	imni=imn
	jmn_pre=imn
C
	if (iyr.lt.90) then
	iyyyy=2000+iyr
	              else
	iyyyy=1900+iyr
	endif
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
C
C preceding month:
C
	if (imn.gt.1) then
	jmn_pre=imn-1			 ! prec_mn
	else
	jmn_pre=12				 ! prec_mn
	jyr_pre=iyr-1			 ! prec_yr
	if (jyr_pre.lt.0) jyr_pre=100+jyr_pre ! 1998 or 1999
	call blet2(jyr_pre,PYR)  ! prec_yr
	endif
	call blet2(jmn_pre,PMN)   ! prec_mn
C
      DY1='01'
	read(DY1,*) rdy1		 !
	idy1=int(rdy1)
	read(DY2,*) rdy2
	idy2=int(rdy2)
C
C Start for station:
	write(*,*) st          ! ++
200	CONTINUE
C Start from 1st day of current month
C-	call blet0(stat,sout)
 
      infile1='d:\web\graf\dat1\YR\stYRMN.txt'	 ! prec. month  Tamara
	INFILE1(21:22)=st							 ! Tamara
	INFILE1(18:19)=pyr							 ! Tamara
	INFILE1(23:24)=pyr							 ! Tamara
	INFILE1(25:26)=pmn							 ! Tamara
	infile2=infile1                              ! current mn
	INFILE2(18:19)=ayr							 ! Tamara
	INFILE2(23:24)=ayr							 ! Tamara
	INFILE2(25:26)=amn							 ! Tamara

      outfile1='d:\web\graf\dat2\YR\stYRMNm.txt'	 ! cur. month Tamara
      OUTFILE1(21:22)=st							 ! Tamara
	outfile1(18:19)=AYR							 ! Tamara
	outfile1(23:24)=AYR							 ! Tamara
	outfile1(25:26)=AMN							 ! Tamara
	outfile2=outfile1  							 ! Tamara
	outfile2(16:16)='3'							 ! Tamara
	outfile2(27:27)='d'							 ! Tamara
	outfile3=outfile1  							 ! Tamara
	outfile3(16:16)='4'							 ! Tamara
	outfile3(27:27)='i'							 ! Tamara
 	OUTFILE4='d:\web\graf\tempmpr\19mpr\'		 ! Tamara
 	OUTFILE4(21:22)=AYR							 ! Tamara
	OUTFILE4(27:28)=st							 ! Tamara
	OUTFILE4(29:30)=AYR							 ! Tamara
	OUTFILE4(31:32)=AMN							 ! Tamara
	OUTFILE5='d:\web\graf\dat5\'				 ! Tamara
	OUTFILE5(18:19)=st							 ! Tamara
	OUTFILE5(20:21)=ayr							 ! Tamara
	OUTFILE5(22:23)=amn							 ! Tamara
	      OUTFILE1(27:)='m.txt'			   		 ! Tamara
		  	OUTFILE2(27:)='d.txt'				 ! Tamara
				OUTFILE3(27:)='i.txt'			 ! Tamara
					OUTFILE4(33:)='.mpr'		 ! Tamara
						OUTFILE5(24:)='c.txt'	 ! Tamara

1100	CONTINUE
C+++
C
	      DO I=1,28
                   DO K=0,23
	      DA(I,K)=0.
	 enddo
	      ENDDO
		do k=1,6
 	xreg(0,k)=0.
	enddo
C
C  =======================================================================
C
  700 format(A128)
   12	FORMAT(3I2,2X,24(F3.1,2X))
      ncnt=0        ! count of days 1,2,...,27   
      if (idy1.ge.27) goto 230	  ! goto input of current month

C  1st input of preceding mon-data
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	nndy=im(jmn_pre)	  ! prec. mn
	nnd1=nndy-25
      OPEN(13,FILE=OUTFILE1)  !dat2/fmed
	OPEN(14,FILE=OUTFILE2)	!dat3/Dlog
	OPEN(15,FILE=OUTFILE3)	!dat4/W-index
	OPEN(16,FILE=OUTFILE4)  !tempmpr
	OPEN(17,FILE=OUTFILE5)	!dat5
C
      OPEN(12,FILE=INFILE1,action='READ')
	do jx=1,4
	read(12,700) TXT  ! 4 extra lines
	enddo
C
      DO I=1,34
	do j=1,4
	LB3(i,j)=0
	enddo
      enddo
C
C  day-to-day input for prec mon
C
	DO 400 jdy_pre=nnd1,nndy  ! for all UT

C Reading foF2 data from styrmn.txt file:
  59   READ (12,12,END=105,ERR=2) JYR,JMN,JDY,(DX(k),k=0,23)
	if ((jyr.eq.jyr_pre).and.(jmn.eq.jmn_pre).and.(jdy.ge.nnd1)) then
	goto 159
	                 else
	goto 59
	                 endif
 159	do iut=0,23
	da(28,iut)=dx(iut)
	enddo
C
C Move data day-by-day up so that last day of month nndy=>day_27:
	do j=2,28			  ! <day-by-day
	do k=0,23			  ! all UT
	da(j-1,k)=da(j,k) ! move data one day up  
	enddo				  ! all UT
	enddo				  ! all days
	ncnt=ncnt+1
  400	CONTINUE		  !<day-by-day
  105	close(unit=12)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C start cycle on day-to-day for current mon  ======================================
C
  230	continue
			OPEN(12,FILE=INFILE2)  ! current month
	do jx=1,4
	read(12,700) TXT  ! 4 extra lines
	enddo
		nndy=im(imn)	 ! end of current month
 	idy=0
C
  499	idy=idy+1	 ! day-by-day input for idy=nndy,...,idy2, current month
      lday=ndoy(iyr,imn,idy) ! function to define day-of-year
	if (idy.gt.idy2) then					  ! idy2???????????
	goto 108 ! end of day-to-day processing 
	endif
       if (idy.gt.nndy) then  !?????????????
 	idy=1
	imn=imn+1
	endif
	call blet2(idy,ADY)
	 READ (12,12,END=108,ERR=2) JYR,JMN,JDY,(DX(k),k=0,23)
	do k=0,23
	da(28,k)=dx(k)
	ff2(idy,k)=dx(k)
	enddo
C Move data one day up: 	if(idy.lt.idy1)  
C
 	do j=2,28			  ! <day-by-day
	do k=0,23			  ! all UT
	da(j-1,k)=da(j,k) ! move data one day up 
	enddo				  ! all UT
	enddo				  !<day-by-day
	if (lday.ge.lday-28) ncnt=ncnt+1
		if (ncnt.lt.27) goto 499

C
   32	format(A13,1X,A2,1X,A12,2X,'glat ='F5.1,1X,'glon ='F5.1)    !txt1='WTEC-index'
   33	format(A13,1X,A2,2X,'glat ='F5.1,1X,'glon ='F5.1)    !
   34	format(2(1X,A4))
C
  109	continue
C
		if (idy.eq.1) then
 	write(*,32) stat,st,txt1m,glatk,glonk	! f-median
	write(13,32) stat,st,txt1m,glatk,glonk
C	WRITE(*,18) cyear,cmn,cdy,ctime
	WRITE(13,18) cyear,cmn,cdy,ctime
C		write(*,201) 
		write(13,201) 
C 	write(*,32) stat,st,txt1d,glatk,glonk  ! DEVlog
	write(14,32) stat,st,txt1d,glatk,glonk
C	WRITE(*,18) cyear,cmn,cdy,ctime
	WRITE(14,18) cyear,cmn,cdy,ctime
C		write(*,201) 
		write(14,201) 
C 	write(*,32) stat,st,txt1w,glatk,glonk  ! W-index
	write(15,32) stat,st,txt1w,glatk,glonk
C	WRITE(*,18) cyear,cmn,cdy,ctime
	WRITE(15,18) cyear,cmn,cdy,ctime
C		write(*,201) 
		write(15,201) 
C 	write(*,33) stat,st,glatk,glonk  ! mpr
	write(16,33) stat,st,glatk,glonk
C	WRITE(*,18) cyear,cmn,cdy,ctime
	WRITE(16,18) cyear,cmn,cdy,ctime
C	write(*,34) AYEAR,TI(imn)
	write(16,34) AYEAR,TI(imn)
C 	write(*,33) stat,st,glatk,glonk  ! 3h-dev
	write(17,33) stat,st,glatk,glonk
C	WRITE(*,18) cyear,cmn,cdy,ctime
	WRITE(17,18) cyear,cmn,cdy,ctime
C	write(*,202)
	write(17,202)
C	write(*,34) AYEAR,TI(imn)
	write(17,34) AYEAR,TI(imn)
	endif
C
   18	format('Date of issue: ',A4,'/',A2,'/',A2,' Time:',A4)
  201	format('YYMMDD|UT 0    1    2    3    4    5    6    7    8'
  	&'    9   10   11   12   13   14   15   16   17   18   19   20'
	&'   21   22   23'/'-------------------------------------------'
     &'-------------------------------------------------------------'
     &'------------------------')
  202	format('_____ START___PEAK___END__DURATION')
c
 	do k=0,23
	iwtec(k)=0
	xmed(k)=0.
	dev(k)=0.
	enddo

C $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C 
  10	CONTINUE
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  CALCULATION OF MEDIAN
C  115   for -27 prec days median
      DO J=1,27
        DO M=0,23          ! Hour-to-hour cycle: variable <m>
        CC(J,M)=DA(j,M)
	ENDDO
	ENDDO
	CALL CMEDIAN27(27)
C
C WTEC index:
C
          DO M=0,23
      XMD=XMED(M)**2	       !NmF2 = foF2**2
	xpar=CC(27,M)**2	    !NmF2 = foF2**2
	devlog=0.
C
      call windex(xpar,xmd,devlog,iw)
C
	DEV(M)=devlog
        if (devlog.GT.0.) then
	 IDEV(M)=nint(DEVLOG*1000+0.5)  ! devlog-index
	if (idev(m).gt.9999) idev(m)=9999
	                else
	 IDEV(M)=nint(DEVLOG*1000-0.5)  ! devlog-index
	if (idev(m).le.-1000) idev(m)=-999
	endif
	if (devlog.eq.999.) then 
	idev(m)=999
	endif
C
	IWTEC(M)=iw
	IDEL(jdy,M)=iw
	IMED(m)=nint(xmed(m)*10.)
	zz=ff2(jdy,m)*10.
	zmed=xmed(m)*10.
	DE=zz**2-zmed**2	! dev=fob**2-fmed**2
	DD=DE/zmed**2*100.		  ! dev=(fob**2-fmed**2)/fmed**2*100%
	resp(jdy,m)=dd		   ! Percentage deviations of NmF2 from median
	     ENDDO
C
C	WRITE(*,158) ayr,amn,ady,(IMED(K),K=0,23)
	WRITE(13,158) ayr,amn,ady,(IMED(K),K=0,23)
C	WRITE(*,158) ayr,amn,ady,(IDEV(K),K=0,23)
	WRITE(14,158) ayr,amn,ady,(IDEV(K),K=0,23)
C	WRITE(*,158) ayr,amn,ady,(IWTEC(K),K=0,23)
	WRITE(15,158) ayr,amn,ady,(IWTEC(K),K=0,23)
 158  FORMAT(3A2,24(1X,I4))
C
C-----------------------------------
C Include Daily Regression of foF2 on fcmed (calibrated median for 27 preceding days):
	ik=0
C Add count of DEV- and DEV+
	ikn=0
	ikp=0

	sx=0.
	sy=0.
	sx2=0.
	sxy=0.

	do 146 k=0,23
C?	zz=da(j+27,k)
	zz=ff2(jdy,k)*10.
	zmed=xmed(k)*10.
	if (zz.eq.0.) goto 146
	ik=ik+1 
      ry(ik)=zz
	rx(ik)=zmed
	sx=sx+rx(ik)
	sx2=sx2+rx(ik)*rx(ik)
	sy=sy+ry(ik)
	sxy=sxy+rx(ik)*ry(ik)
  146	continue                ! cycle K
	if (ik.lt.3) then
	xreg(jdy,1)=xreg(jdy-1,1)
	xreg(jdy,2)=xreg(jdy-1,2)
	xreg(jdy,3)=xreg(jdy-1,3)
	sx=xreg(jdy,1)
	sy=xreg(jdy,2)
	ra=xreg(jdy,3)
	goto 145
	             else
	sx=sx/ik
	sx2=sx2/ik
	sy=sy/ik
	sxy=sxy/ik
	 RA=(SXY-SX*SY)/(SX2-SX*SX)
	xreg(jdy,1)=sx
	xreg(jdy,2)=sy
	xreg(jdy,3)=RA
	            endif
  145	continue
C Include Daily Standard Deviation (DSD) from daily regression line:
C Additional : DSD- and DSD+
	 xreg(jdy,4)=0.	  ! DSD
	xreg(jdy,5)=0.	  ! DSD-
	xreg(jdy,6)=0.	  ! DSD+
	do 149 i=0,23
	zz=ff2(jdy,i)*10.
	zmed=xmed(i)*10.
	xlev(i)=sy+ra*(zmed-sx)
Crem	     if (ff2(jdy,i).eq.0.) goto 149
	xreg(jdy,4)=xreg(jdy,4)+(zz-xlev(i))**2.	      ! DSD
	if (zz.lt.xlev(i)) then
	 ikn=ikn+1
	 xreg(jdy,5)=xreg(jdy,5)+(zz-xlev(i))**2.	  ! DSD-
	else
	ikp=ikp+1
	 xreg(jdy,6)=xreg(jdy,6)+(zz-xlev(i))**2.	  ! DSD+
	endif
  149	continue	    ! cycle i
  	if (ik.gt.0) xreg(jdy,4)=sqrt(xreg(jdy,4)/ik)			  ! DSD
	if (ikn.gt.0) xreg(jdy,5)=-sqrt(xreg(jdy,5)/ikn)		  ! DSD-
	if (ikp.gt.0) xreg(jdy,6)=sqrt(xreg(jdy,6)/ikp)			  ! DSD+
C		 
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C 3-h deviations
C
150	continue         ! cycle jj
	 ncnt=26
      goto 499		  ! to the next day processing
C
c
    2 CONTINUE
	       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
	   	pause ' '
	goto 102
  108 continue
C
C .mpr results
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      LDNR=IDY2
      LDY=0
      KPN=24*LDNR 
	LDMN=1
C Daily mean, peak and rate-variability of foF2 => results.mpr:	
 71   L=0 
      LH1=0
	LT2=-1
	YY(0)=0.
 72   LDY=LDY+1 
	IF (LDY.gt.LDNR) GOTO 1301
      LCNT=0 
	AVE=0. 
	PE=0. 
	DI=0.
  75  L=L+1
      DO K=0,23

c REM REPLACE z=z*z for NmF2 later when calculating results.dev, results.ind, results.dis
	Z=ff2(LDY,K)*10.
      IF (Z.gt.0.) then
C--	DEV(L,24)=DEV(L,24)+1.
	LH1=K
	else
	LCNT=LCNT+1
	endif
CDD__      DEV(L,K)=Z      ! NOT!!!!!!
      AVE=AVE+Z
      IF (PE.LT.Z) PE=Z
      YY(K+1)=Z
      ENDDO                       ! End diurnal cycle
      LCNN=24-LCNT 
	IF (LCNN.EQ.0) GOTO 110
 95   IF (YY(0).gt.0) GOTO 97 
      YY(0)=YY(LH1+1) 
      LT2=LH1-24
 97   AVE=AVE/LCNN 
      LT1=LT2 
	Y1=YY(0)
       DO 103 I=1,24
      IF (YY(I).EQ.0.) GOTO 103
       LT2=I-1
       DI=DI+ABS((YY(I)-Y1)/(LT2-LT1))
      LT1=LT2 
	Y1=YY(I)
  103  CONTINUE                   
      YY(0)=YY(LH1+1)
	LT2=LH1-24
      DD=DI/LCNN
c REM PRINT DY,AVE;PE;DD;CNT
C For NmF2: AVE=INT(AVE/100+.5) : PE=INT(PE/100+.5) : DI=INT(DD/10+.5)
C For foF2:
C      AVE=INT(AVE+.5) : PE=INT(PE+.5) : DI=INT(DD*10+.5)
 	DI=DD*10.
  110 LB3(L,1)=int(AVE +0.5)
      LB3(L,2)=int(PE+0.5)
	LB3(L,3)=int(DI+0.5)
	LB3(L,4)=LCNT
c PRINT LDY,AV;PE;DI;LCNT
 168  WRITE(16,169) LDY,LB3(L,1),LB3(L,2),LB3(L,3),LB3(L,4)
     +,xreg(L,4),xreg(L,5),xreg(L,6)
C	WRITE(*,169) LDY,LB3(L,1),LB3(L,2),LB3(L,3),LB3(L,4)
C     +,xreg(L,4),xreg(L,5),xreg(L,6)
 169   FORMAT(1X,I2,3(I4),1X,I2,3(1X,F6.2))
C 169   FORMAT(1X,I2,3(I4),1X,I2)
  120 GOTO 72
C
C+++++++++++++++++
 1301  CONTINUE
C Disturbances 3h,% results
 1324 L=0 
          LDNR=IDY2
      L=0 
	LC=0
	LDY=0 
	  LC=LC+LDNR 
920	LDY=LDY+1 
	  IF (LDY.gt.LDNR) GOTO 1540
	L=L+1 
	KMI=0 
	KMA=0 
	idin=0
	indin=0
	idax=0
	indax=0
	LT1=0
	LT2=0
	LT3=0
	LT4=0
	LDT12=0
	LDT34=0
C
	 do 1060 k=0,23
      pdd=resp(l,k)	! = percentage deviation
	idd=nint(pdd)	! dev%
	indd=idel(l,k)	 ! Indices
	IF (K.gt.0) THEN
	id1=idel(L,K-1)	 ! Indices
	 ELSE 
	 id1=idel(L-1,23)  ! Indices
	endif
	IF (K.LT.23) THEN
	id2=idel(L,K+1)     ! Indices
	              ELSE
		IF (L.lt.LDNR) then
	id2=idel(L+1,0)     ! Indices
	    else
	    id2=999
	    endif
	ENDIF
 1000	IF (idd.eq.999) GOTO 1060
	 IF((id1.eq.99).AND.(id2.eq.99)) GOTO 1060
      IF (idd.lt.idin) then 
	idin=idd
	rdin=pdd
	indin=indd
	endif
	IF (idd.gt.idax) then 
	idax=idd
	rdax=pdd
	indax=indd
	endif
      IF (idin.eq.idd) KMI=K
      IF (idax.eq.idd) KMA=K
 1060	continue
C	PRINT L,"din=";DIN,"dax=";DAX

C !!!!!!!!!!!! Different thresholds for D- and D+ !!!!!!!!!!!!!!!!!!!!!!
C	DURATION FOR -40% =<(DEV%NmF2)<= +40% is changed to:
C				 -30% =<(DEV%NmF2med-reg)<= +43%		 !
C                   -0.155=<alog10(devNm/Nmed-reg)<=0.155
C                  -16% < dev%fof2/fomed-reg < 20%       
C ///	LTHN=-30
		LTHN=-3	  !	Indices threshold

C	LTHN=-20	 ! According to index=-4 for delog<-.2
C Ole:	LTHN=-40
C ///	LTHP=43
	LTHP=3        !	Indices	threshold

C Ole:	LTHP=40
C      LTHP=20		 ! According to index=+4 for delog>+.2
C	LTM=jd3(L+27,2)*10000+jd3(L+27,3)*100+KMI
C	 LHM=jd3(L+27,2)*10000+jd3(L+27,3)*100+KMA
	LTM=jmn*10000+ldy*100+KMI
	 LHM=jmn*10000+ldy*100+KMA
C Negative event:
	IF (indin.gt.LTHN) GOTO 1280
	K1=KMI  
	J1=L  
	ISM=indin 
	 KK=1
1140	K2=K1  
	J2=J1
	IF ((J1.eq.0).AND.(K1.eq.0)) GOTO 1200
	K1=K1-1  
	IF (K1.ge.0) GOTO 1180
	J1=J1-1 
	K1=K1+24
1180	IF (IDEL(J1,K1)*IDEL(J2,K2).le.0.) GOTO 1200
	KK=KK+1  
	ISM=ISM+idel(J1,K1)       ! Indices
	 IF (ISM/KK.le.LTHN) then
	 GOTO 1140
	else
 	 		ISM=ISM-idel(J1,K1)     ! Indices
 	 KK=KK-1
	endif
1200	LT1=jmn*10000+ldy*100+K2  
	LD1=J2  				 
	LTD1=K2
	K2=KMI  
	J2=L  
1220	K1=K2  
	J1=J2
	K2=K2+1  
	IF (K2.lt.24) GOTO 1250
	J2=J2+1 
	K2=K2-24
 1250	IF (idel(J1,K1)*idel(J2,K2).le.0.) GOTO 1270      ! Indices
	KK=KK+1  
		ISM=ISM+idel(J2,K2)    ! Indices
	IF (ISM/KK.le.LTHN) GOTO 1220
1270	LT2=jmn*10000+ldy*100+K1
	LD2=J1  
	LTD2=K1
c Positive event:
1280	IF (INDAX.lt.LTHP) GOTO 1440
	K1=KMA  
	J1=L  
	ISM=INDAX 
	 KK=1
1300	K2=K1 
	 J2=J1
	IF ((J1.eq.0).AND.(K1.eq.0)) GOTO 1360
	K1=K1-1 
	 IF (K1.ge.0) GOTO 1340
	J1=J1-1 
	K1=K1+24
1340	IF (idel(J1,K1)*idel(J2,K2).le.0.) GOTO 1360
	KK=KK+1 
		 ISM=ISM+idel(J1,K1)      ! Indices
	 IF ((ISM/KK.ge.LTHP).AND.(RESP(J1,K1).lt.999.)) then
	 GOTO 1300
	else
			  ISM=ISM-idel(J1,K1)      ! Indices
	   KK=KK-1
	   endif
1360  LT3=jmn*10000+ldy*100+K2  
       LD3=J2 
	  LTD3=K2
	  K2=KMA 
	  J2=L 
1380	K1=K2 
	 J1=J2
	K2=K2+1 
	 IF (K2.lt.24) GOTO 1410
	J2=J2+1 
	K2=K2-24
 1410 	  IF (idel(J1,K1)*idel(J2,K2).le.0.) GOTO 1430
	KK=KK+1 
		 ISM=ISM+idel(J2,K2)	 ! Indices
	  IF ((ISM/KK.ge.LTHP).AND.(RESP(J2,K2).lt.999.)) GOTO 1380
1430  LT4=jmn*10000+ldy*100+K1
      LD4=J1 
	 LTD4=K1
1440	IF (INDIN.gt.LTHN) GOTO 1460
	 LDT12=(LD2-LD1)*24+LTD2-LTD1+1
1460	IF (INDAX.lt.LTHP) GOTO 1490
	LDT34=(LD4-LD3)*24+LTD4-LTD3+1
      
C	pause ' '
1490	CONTINUE
		II=L
 	LB2(L,1)=nint(RDIN)		   ! I4  min D-
	LB2(L,2)=LT1			   ! I4	 hr1-
	LB2(L,3)=LTM 			   ! I4	 hrmin
	LB2(L,4)=LT2 			   ! I4	 hr2-
	LB2(L,5)=LDT12			   ! Duration D-
      LB2(L,6)=nint(RDAX)   		   ! I4	 max D+
	LB2(L,7)=LT3               ! I4	 hr1+
	 LB2(L,8)=LHM 			   ! I4	 hrmax
	LB2(L,9)=LT4			   ! I4	 hr2+
	LB2(L,10)=LDT34			   ! I3	 Duration D+

	GOTO 920
C
1540	continue
C
1670  continue

C 

	jj=0
	do 1970 j=1,ii
	if (lb2(j,5).lt.3) goto 1920
1919		jj=jj+1
	do k=1,5
	LB1(JJ,K)=LB2(J,K)
	enddo
 1920	IF (LB2(J,10).lt.3) GOTO 1970
1918	jj=jj+1
	do k=6,10
	LB1(JJ,K-5)=LB2(J,K)
	enddo
 1970	continue
 	 ii=jj
1980	if (ii.eq.0) goto 1700
      if (ii.eq.1) goto 2250
      j=1
 1990	IF (LB1(J+1,2).eq.0) GOTO 2140
       IF ((j.gt.1).and.(LB1(j-1,2).eq.LB1(j-2,2))) then
	j=j-2
	GOTO 2140
	endif

c	PRINT LB1(J,2),LB1(J+1,2)
	IF (lb1(j+1,2).gt.lb1(j,4)) goto 2100
	IF((LB1(J+1,2).ge.LB1(J,2)).AND.(LB1(J+1,4).le.LB1(J,4))) 
	+ GOTO 2140

C Add control lb1(j+1,2).le.lb1(j,4) :

	if (lb1(j+1,2).le.lb1(j,4)) then 
	if (lb1(j+1,1)*lb1(j,1).lt.0) then
	 if (lb1(j+1,2).lt.lb1(j,2)) goto 2090
	else
	 goto 2140
	endif
	if (lb1(j+1,2).eq.lb1(j,4)) then
	lb1(j,5)=lb1(j,5)+lb1(j+1,5)-1
	lb1(j,4)=lb1(j+1,4)
	goto 2140
	                             else
	if (lb1(j,5).gt.lb1(j+1,5)) then
	goto 2140
	                            else
	goto 2100
		endif
	endif
	endif

	IF (LB1(J,2).lt.LB1(J+1,2)) goto 2100
 2090 	do k=1,5
	LC(K)=LB1(J+1,K)
	LB1(J+1,K)=LB1(J,K)
	LB1(J,K)=LC(K)
	enddo
C	PRINT J,LB1(J,1),LB1(J,2),LB1(J,3),LB1(J,4),LB1(J,5)
 2100	j=j+1
C
2110	IF (J.lt.II) GOTO 1990
	goto 2250
 2140	ii=ii-1
	i1=j+1
		IF (LB1(J,5).le.LB1(J+1,5)) THEN
 	 I1=J 
	 ELSE 
	 I1=J+1
	endif

	IF((LB1(J+1,2).eq.LB1(J,2)).AND.(LB1(J+1,4).eq.LB1(J,4))) then
	if (abs(lb1(j,1)).lt.abs(lb1(j+1,1))) then 
 		do k=1,5
	LB1(J,K)=LB1(J+1,K)
	enddo
	endif
						j=j+1
      i1=j
	endif
C
2150	DO i=i1,ii
	do k=1,5
	LB1(I,K)=LB1(I+1,K)
	enddo
	ENDDO
 	goto 1980

 2250	continue

C  Results for disturbed periods:
 	DO 290 J=1,II
	imon0=lb1(j-1,2)/10000
	imon1=lb1(j,2)/10000
C Limit output by results for given month:
	if (imon1.ne.jmn) goto 1700
C	write(*,280) (LB1(j,k),k=1,5)
	write(17,280) (LB1(j,k),k=1,5)
  280	Format(1X,I4,3(1X,I6),1X,I3)
C--	LB1(j,1)=ltemp
  290		continue
 1700	continue
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
  113 	CONTINUE
C
  102	continue
      close(unit=13)
      close(unit=14)
	close(unit=15)
	close(unit=16)
	close(unit=17)
 	close(unit=12)

	RETURN              
	END
C-------------------------------------------------------------------
c VERIFICATION OF MEDIAN ================
      subroutine cmedian27(ndnr)
C Input file: CC(27,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(27,0:23),XME(0:23),X1(31),X2(31)
		COMMON /BCC1/CC,XME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
      IF (CD1.LT.XD1) THEN 
	XMD=X2(ND2)
	else
	XMD=(X2(ND1)+X2(ND2))/2.
	ENDIF
C 1000 IF (MM.eq.0) MD=0
C
 1020 XME(M)=XMD
 1030 CONTINUE
c
 1050 RETURN
      END
c-------------------------------------------------------------------
      subroutine windex(xpar,xmed,delog,iw)
C
C   Procedure to calculate the ionospheric weather W index
C
C   Input: xpar = NeF2  - instantaneous value of the F2 layer peak electron density 
C      or  xpar = TECi  - instantaneous value of GPS-derived total electron content
C    		 xmed = NmF2  - quiet reference (median) value of the F2 layer peak electron density
C      or	 xmed = TEC m - quiet reference (median) value of total electron content
C
C   Output: ionospheric weather W index characterizing ionospheric and plasmaspheric activity:
C           W = 0, +1 or -1 (quiet state)
C           W = +2 or -2 (moderate disturbance)
C           W = +3 or -3 (moderate storm)
C           W = +4 or -4 (intense storm)
C
C   Includes logarithmic scale indices -4,-3,-2,-1,0,1,2,3,4
C   according to thresholds of 
C           log10(xpar/xmed)=-0.999,-0.301,-0.155,-0.045,0,0.045,0.155,0.301,0.999  
C
C   Ref.Gulyaeva, T.L.,, I. Stanislwska, and M. Tomasik. Ionospheric weather: Cloning missed 
C       foF2 observations for derivation of variability index. Annales Geophysicae, 26, N.2, 
C       315-321, 2008.
C       Gulyaeva, T.L.,and I. Stanislwska, Derivation of a planetary ionospheric storm index. 
C       Annales Geophysicae, 26, N.9, 2645-2648, 2008 .
C
      DIMENSION TR(7)
	real xpar,xmed
	INTEGER IIN(7)
   		data IIN/-3,-2,-1,0,1,2,3/           ! ID-index
	data TR/-.301,-.155,-.045,0.0
	+,.045,.155,.301/
C  Temp:
    	 if (delog.ne.0.) goto 5   ! temp if delog is entered
	      delog=alog10(XPAR)-alog10(XMED)
   5		if (delog.gt.tr(7)) then
		iw=4
	goto 2
		endif 
		if (delog.eq.0.) then
			iw=0
	goto 2
	endif
	      if(delog.le.tr(1)) then
	iw=-4                 ! W-index
	goto 2
	endif
	if (delog.ge.tr(7)) then
	iw=4				  ! W-index
 	goto 2
	endif
C
	do 1 n=1,7
	if (delog.lt.0.) then
	if ((delog.ge.tr(n)).and.(delog.lt.tr(n+1))) then
	iw=iin(n)              ! W-index
	endif
	      else
	if ((delog.gt.tr(n-1)).and.(delog.le.tr(n))) then
	iw=iin(n)              ! W-index
	endif

	endif
   1	continue
C
   2  continue
C
	RETURN
	END
C
C
C ===============================================================
