      subroutine subfur4(fdat)
C.......................................................Dec. 2011
C Furie expansion of diurnal foF2 using 96 prec. values = 4 days of UT
C Input data fdat(k,ut), k=1,2,3,4, ut=0:23
C Results fdat(5,0:23)
C
      dimension fdat(5,0:23)
	+,AI(5),BI(5),FUA(5,24),FUB(5,24)
	COMMON /BLFUR/FUA,FUB        ! Coeff. Furie for Ai, Bi
	PARAMETER (n=96,p=24.,pip=.2617994)
C
C Parameters:
c	PI=ATAN(1.0)*4.
c	P=24.
c	N=96
c	 pip=2*pi/p 
C
crem
C mean of 96 values:
	xav=0.
	do j=1,4
	do i=0,23
	xav=xav+fdat(j,i)
	enddo
	enddo
	xav=xav/N
C
	do ii=1,5
	ai(ii)=0.
	bi(ii)=0.
	DO nn=1,4  ! 4 times repeat coefs. for Ai and Bi
	do j=1,24  ! set of coefficiens
c-	nj=j-1+(nn-1)*24
c-	xval=fdat(nj)
	xval=fdat(nn,j-1)
c
		ai(ii)=ai(ii)+xval*fua(ii,j)
	bi(ii)=bi(ii)+xval*fub(ii,j)
	enddo
	ENDDO
	ai(ii)=ai(ii)*2./N
	bi(ii)=bi(ii)*2./N
	enddo
C synthesis
		sum=xav
	do iut=0,23
c-	fres(iut)=xav
      fdat(5,iut)=xav
	do ii=1,5
	fdat(5,iut)=fdat(5,iut)+ai(ii)*fua(ii,iut+1)
	&+bi(ii)*fub(ii,iut+1)
	 enddo
	enddo
  101	CONTINUE
crem	close (unit=15)
	RETURN
	end
