	program convercj
C.........................................................Apr. 2012
C Maps in IONEX format
C ........................................................Dec. 2011
C Exclude	usage of fres, hres from SMI option
C ........................................................Dec. 2009
C Construct *.br file = (preceding month + current month) from \web\ results
C
C Add TEC calculation adjusted to foF2&hmF2, arrange input of kp-index
C
C ........................................................Aug. 2009
C Add conj.point restoration with SUBCONP.FOR subroutine...........
C
C ........................................................Oct. 2008
C Mover med restoration to 14 preceding days 
C Include: t0=1(0) write(not write) results for thia station/days
C Include calculation of period for median in subclone.for
C 
C ........................................................Aug. 2007
C Include <status.txt> file for set of stations....................
C ........................................................Mar. 2007
C Cycle on stations/data
C
C Combined extraction f,m data from different sources
C
c  [1] Subr "SUBRAL1" EXTRACT HOURLY "FOF2/M3000 " FROM RAL FILES
c  [2] Subr "SUBSECG" from converted data from SEC files
c  [3] Subr "SUBDIAS2" from DIAS files or SUBNGDC from NGDC files
c  [4] Subr "SUBSGO" from SGO files xxxx remove

	DIMENSION IM(0:12)
	+,NSUBS(76),GLATS(76),GLONS(76),DIPS(76)
	+,if2(31,0:23),ih2(31,0:23),im3(31,0:23)
	REAL rkp(0:366,0:7),prekp(0:7)
	+,CLATS(76),CLONS(76) ! conj. point coordinates
	INTEGER*2 JFS(76),JHS(76),JTS(76),NFULF,NFULM,MAXD2
	+,id1,id2
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ,resf(0:31,24),resm(0:31,24)
	CHARACTER*128 outfile1,outfile2
     +,outfile3,infile,routfile
	+,outfile4,infile1,infile3,infile4
	CHARACTER*30 STINP(76),STNAME
	CHARACTER*4 YEARR(76),TTT,YEAR
	CHARACTER*13 STAT,STATS(76)
	CHARACTER*1 fmh
	CHARACTER*2 ST,AMN,DY1,DY2,CDAY(0:31),dd1,dd2,YY,DY11,DY22
	+,STTT
	+,STS(76),AMNS(76),DY1S(76),DY2S(76),FULF(76),FULM(76),STCL(76)
	COMMON /BL1/ST,YEAR,YY,AMN,DY1,DY2,DD1,DD2,ID1,ID2,JF,JH,JT,DY22
	+,STNAME
	COMMON /BL2/ STAT,GLAT,GLON,DD,TTT,ZZ,DIP
	COMMON /BL3/ STATS,STS,GLATS,GLONS,JFS,JHS,II,AMNS,JTS
	COMMON /BL4/ FULF,FULM,NFULF,NFULM,MAXD2
	COMMON /BL5/ APROX,BPROX
	COMMON /BL6/ CLATS,CLONS
	COMMON /BL7/ YEARR
	COMMON /BL8/ IF2,IM3,IH2
	COMMON /FIKP/rkp,prekp
 	 COMMON   /CONST1/HUMR,DUMR,FAP,INDAP,AKP,COV,RZS,HMLON
	DATA IM/31,31,28,31,30,31,30,31,31,30,31,30,31/

CC
CC
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TTT(1:4)=TT(1:4)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT
      WRITE(*,*) 'Check <STATUS.TXT> file*******'
	pause ' '
c
C
C
C Prepare List of full data -stations
	APROX=2.876820E-02
	BPROX=4.601528
	nfulf=0
	nfulm=0
	do i=1,76
	fulf(i)='00'
	fulm(i)='00'
	enddo
C First read status file:
	infile='status.txt'
C
	OPEN(10,FILE=INFILE)		
	ii=0
	maxd2=0
	do 103 ist=1,76
	read(10,99) STAT,ST,NSUB,GLAT,GLON,DIP,YEAR,AMN,DY1,DY2,JF,JH,JT
	+,STTT,STNAME,XLAT,XLON ! c.p. lati & longi
 	if ((jf.eq.0).and.(jh.eq.0).and.(jt.eq.0)) then
	 goto 103
		endif
	write(*,99) STAT,ST,NSUB,GLAT,GLON,DIP,YEAR,AMN,DY1,DY2,JF,JH,JT
	+,STTT,STNAME,XLAT,XLON
   99	format(1X,A13,A2,1X,I1,3(1X,F5.1),1X,A4,3(1X,A2),3(2X,I1),1X,A2
     +,1X,A30,2(1X,F5.1))
	ii=ii+1
		STATS(II)=STAT
 	STS(II)=ST
	NSUBS(II)=NSUB
	GLATS(II)=GLAT
	GLONS(II)=GLON
	DIPS(II)=DIP
	YEARR(II)=YEAR
	YY=YEAR(3:4)
	AMNS(II)=AMN
	DY1S(II)=DY1
	DY2S(II)=DY2
	JFS(II)=JF
	JHS(II)=JH
	JTS(II)=JT
	STCL(II)=STTT
	STINP(II)=STNAME
	CLATS(II)=XLAT
	CLONS(II)=XLON
C
	if (jf.gt.0) then
	nfulf=nfulf+1
	fulf(nfulf)=st
	endif
C
	if (jh.gt.0) then
	nfulm=nfulm+1
	fulm(nfulm)=st
	endif
C	YY=YEAR(3:4)
	if (ii.eq.1) then
CREM      CALL SUBKPM
      CALL SUBKPC
	endif
  103	continue
	close(unit=10)
	iinum=ii
CTemp	
C Start cycle on stations:
     	do 105 ist=1,II
C---	goto 105          ! TEMP
	STAT=STATS(IST)
	ST=STS(IST)
	NSUB=NSUBS(IST)
	GLAT=GLATS(IST)
	GLON=GLONS(IST)
	DIP=DIPS(IST)
	YEAR=YEARR(IST)
	YY=YEAR(3:4)
	AMN=AMNS(IST)
	DY1=DY1S(IST)
	DY2=DY2S(IST)
	JF=JFS(IST)
	JH=JHS(IST)
	JT=JTS(IST)
	STTT=STCL(IST)
	STNAME=STINP(IST)
		write(*,*) stat,st

   38	WRITE(*,*)'year:',YEAR,' month:',amn,' day1:',dy1,' day2:',dy2
C
      YY=YEAR(3:4) 
	read(amn,*) rmon
 	mn=int(rmon)
	read(yy,*) yr
 	iyr=int(yr)
	read(dy1,*) d1
 	id1=int(d1)
	read(dy2,*) d2
  	id2=int(d2)
	if ((st.eq.'wk').or.(st.eq.'kk')) goto 159     ! avoid for WK & KK
	if (id2.gt.maxd2) maxd2=id2  ! select max Day2 of inputs
  159	z1=yr/4.
	  jz=int(z1)*4
	IF(jz.EQ.iyr) THEN
               IM(2)=29
        ELSE
                IM(2)=28
	       ENDIF
	IDNR=IM(MN)
	LHR=24*IDNR
		DD1='01' ! for input file title
C Specify DD2 for given month:
C		dd2='28','29','30','31' ! for input file title
C define day of end of month:
	jd=idnr
	call blet2(jd,DD2)
C
	 outfile1='d:\web\idce\styrf.br'
	outfile1(13:14)=ST
	outfile1(15:16)=YY
C	outiles are different for ,f. and <h>
	outfile1(17:20)='f.br'
C	
	outfile2=outfile1
	outfile2(17:20)='t.br'
		outfile3=outfile1
	outfile3(17:20)='m.br'
	outfile4=outfile3
	outfile4(17:20)='h.br'
	infile1='d:\web\graf\YEAR\styrf.br'
	infile1(13:16)=YEAR
	infile1(18:)=outfile1(13:)
	infile3=infile1
	infile3(18:)=outfile3(13:)
	infile4=infile1
	infile4(18:)=outfile4(13:)
C
C	
	select case (nsub)
C RAL:
	case (1)
c==    1 call subral(cday,if2,im3)
C        
    1 call subral2(cday,infile1,infile3,infile4)
	goto 108    ! output results
C SEC:
	case (2)
    2 if (jt.eq.3) then
	 	if (DY1.eq.'01') then
 	jt=1
	               else
      jt=2
                 endif
	call subsec2(cday,infile1,infile3,infile4)
	else
	goto 108
	endif
	goto 108      ! output results
C DIAS:
	case (3)
	routfile=outfile1             !ngdc
c++    3 call subngdc(cday,if2,im3,ih2)	  ! ngdc!!!
	call subionka2(cday,if2,im3,ih2)           ! Novosibirsk

    3 continue
CTemp    3 call subdias(cday,if2,im3)		  ! dias
CTemp      outfile1(18:21)='f.br'            !dias
	 
	goto 108      ! output results
	case (4)
C SGO:
    4 continue
      call subsgo2(cday,resf,resm)
c--	if (id1.gt.1) id1=id1-1
c--	call blet2(id1,DY1)
	goto 108      

	case (5)
    5 continue	 
	call subxml(cday) ! Dourbes, El Arenosillo
	goto 108      ! output results
c
	case (6)
    6 continue	 
	call subsao(cday) ! Austin, Chung-Li, Sjj, Chinese (5)
	goto 108      ! output results


C+++++++
	end select 
C output results

  108	continue
C NEW++++ JT=2 means REMOVE the preceding day line from output files:
	  if (JF.GT.0) then
        fmh='f'
c==	  call subremow(fmh,outfile1)	  ! f.br
	  call subrecon2(fmh,outfile1)	  ! f.br
	endif
	  
	    if (JH.GT.0) then 
	fmh='m'
	  call subrecon2(fmh,outfile3)	  ! m3.br
	fmh='h'
	  call subrecon2(fmh,outfile4)	  ! hm.br
      endif
	fmh='t'
	  call subrecon2(fmh,outfile2)	  ! TEC
C+++++++++++++++++++++++++++++++++++++++++++++++
c--		OPEN(12,FILE=OUTFILE1,ACCESS='APPEND') 

c--	if (jh.gt.0) then
c--	OPEN(14,FILE=OUTFILE3,ACCESS='APPEND') 
c--	endif
c
  702		JFS(IST)=JF
	JHS(IST)=JH
       call subdevxx(ist)    ! DEVLOG
  102	continue
crem      write(*,98) STAT,ST,NSUB,GLAT,GLON,DIP,YEAR,AMN,DY1,DY2,JF,JH,JT
crem	+,STTT,STNAME
c	write(19,98) STAT,ST,NSUB,GLAT,GLON,DIP,YEAR,AMN,DY1,DY2,JF,JH,JT
   98	format(1X,A13,A2,1X,I1,3(1X,F5.1),1X,A4,3(1X,A2)
     +,1X,'f',I1,1X,'h',I1,1X,'t',I1,1X,A2,1X,A23)
c	pause' ' 
  105	continue
	
c	close(unit=19)

C +++++++++++++++Avoid CLONE for COMPLETE data for given day
C
 1000	 continue
C	
C ++++++++++++ Prepare for c.p. calculations ++++++++++++
	DO 2001 ist=1,IINUM
	stat=stats(ist)
	 st=sts(ist)
	sttt=stcl(ist)
	year=yearr(ist)
	yy=year(3:4)
	amn=amns(ist)
	read(amn,*) mn
	dy11=dy1s(ist)
	dy22=dy2s(ist)
	read(dy11,*) d1  ! starting day for clone
  	id1=int(d1)
	read(dy22,*) d2	 ! ending day for clone
  	id2=int(d2)
C
c-	if (jfs(ist).eq.0) goto 2001
	call subconpj(ist)      ! conj.point
 2001	continue
	pause ' '
	STOP
	END
c  
C***********************************************************
