	program converg1b
C.........................................................Mar. 2014
C
C.........................................................Dec. 2013
C Use data & results in /graf/
C
C.........................................................Oct. 2013
C Use fcF2 & hcF2 results of /graf/
C
C.........................................................Apr. 2012
C Maps in IONEX format
C ........................................................Dec. 2011
C Exclude	usage of fres, hres from SMI option
C ........................................................Dec. 2009
C Construct *.br file = (preceding month + current month) from \web\ results
C
C Add TEC calculation adjusted to foF2&hmF2, arrange input of kp-index
C
C ........................................................Aug. 2009
C Add conj.point restoration with SUBCONP.FOR subroutine...........
C
C ........................................................Oct. 2008
C Mover med restoration to 14 preceding days 
C Include: t0=1(0) write(not write) results for thia station/days
C Include calculation of period for median in subclone.for
C 
C ........................................................Aug. 2007
C Include <status.txt> file for set of stations....................
C ........................................................Mar. 2007
C Cycle on stations/data
C
C Combined extraction f,m data from different sources
C
c  [1] from TK files (TK)
c  [2] from SEC files
c  [3] from Ionka files (NS)
c  [4] from SGO files (SO)
c  [5] from .sao files (AU, SJ)
c  [6] from .xml files (DB)


	DIMENSION IM(0:12)
	+,NSUBS(59),GLATS(59),GLONS(59)
	+,if2(31,0:23),ih2(31,0:23),im3(31,0:23)
	+,R12y(0:12)
	REAL rkp(0:366,0:7),prekp(0:7)
	+,CLATS(59),CLONS(59) ! conj. point coordinates
	INTEGER*2 JFS(59),JHS(59),JTS(59),NFULF,NFULM,MAXD2
	+,id1,id2
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ,resf(0:31,24),resm(0:31,24)
	CHARACTER*128 outfile1,outfile2,outfile3,txt
	+,outfile4,infile1,infile2,infile3,infile4
	CHARACTER*30 STINP(59),STNAME
	CHARACTER*4 YEARR(59),TTT,YEAR
	CHARACTER*13 STAT,STATS(59)
	CHARACTER*1 fmh
	CHARACTER*2 ST,AMN,DY1,DY2
     +,dd1,dd2,YY,DY11,DY22
	+,STTT
	+,STS(59),AMNS(59),DY1S(59),DY2S(59),FULF(59),FULM(59)
	COMMON /BL1/ST,YEAR,YY,AMN,DY1,DY2,DD1,DD2,ID1,ID2,JF,JH,JT,DY22
	+,STNAME
	COMMON /BL2/ STAT,GLAT,GLON,DD,TTT,ZZ,R12
	COMMON /BL3/ STATS,STS,GLATS,GLONS,JFS,JHS,II,AMNS,JTS
	COMMON /BL4/ FULF,FULM,NFULF,NFULM,MAXD2
	COMMON /BL5/ APROX,BPROX
	COMMON /BL6/ CLATS,CLONS
	COMMON /BL7/ YEARR
	COMMON /BL8/ IF2,IM3,IH2
	COMMON /FIKP/rkp,prekp
	DATA IM/31,31,28,31,30,31,30,31,31,30,31,30,31/
	DATA STS/'at','bc','bp','br','cb','ch','cn','cq','cs','cw'	  !DEC2013
 	+,'cr','db','dw','ea','eb','gm','gr','gu','ha','he'			  !DEC2013
     +,'ho','ic','jj','jm','jr','kh','kk','lg','lv','ml'			  !DEC2013
     +,'mm','mo','mq','mw','nd','ni','ok','pe','pq','ps'			  !DEC2013
     +,'qn','rm','ro','sq','tr','wk','wp','wz','yg','tv'			  !!!
     +,'tk','mg','sd','rv','tz','au','sj','ns','so'/				  !!!
C      
	DATA STATS/												  !DEC2013
     + 'Athens.      ','Boulder.     ','Beijing.     '		  !DEC2013
     +,'Brisbane.    ','Canberra.    ','Chilton.     '		  !DEC2013
     +,'Camden.      ','Chongqing.   ','Cocos_Is.    '		  !DEC2013
     +,'Casey.       ','Christchurch.','Dourbes.     '		  !DEC2013
     +,'Darwin.      ','ElArensillo. ','Roquetes.    '		  !DEC2013
     +,'Gibilmanna.  ','Grahamstown. ','Guangzhou.   '		  !DEC2013
     +,'Hainan.      ','Hermanus.    ','Hobart.      '		  !DEC2013
     +,'I_Cheon.     ','Jeju.        ','Jicamarca.   '		  !DEC2013
     +,'Juliusruh.   ','Khabarovsk.  ','Kokubunji.   '		  !DEC2013
     +,'Longyearbyen.','Louisvale.   ','Manzhouli.   '		  !DEC2013
     +,'Murmansk.    ','Moscow.      ','MacQuarue_Is.'		  !DEC2013
     +,'Mawson.      ','Niue.        ','Norfolk_Is.  '		  !DEC2013
     +,'Okinawa.     ','Perth.       ','Pruhonice.   '		  !DEC2013
     +,'Port_Stanley.','Qaanaaq.     ','Ramey.       '		  !DEC2013
     +,'Rome.        ','Scott_Base.  ','Tromso.      '		  !DEC2013
     +,'Wakkanai.    ','Wallops.     ','Warsaw.      '		  !DEC2013
     +,'Yamagawa.    ','Townsville.  ','Tomsk.       '        !!!
     +,'Magadan.     ','Salehard.    ','Rostov.      '		  !!!
     +,'Tunguska.    ','Austin.      ','St_Johns.    '		  !!!
     +,'Novosibirsk. ','Sodankyla.   '/						  !!!

	DATA GLATS/
	+  38.4, 40.0, 40.0,-27.5,-35.3, 51.6,-34.0, 29.5,-12.2,-66.3
	+,-43.6, 50.1,-12.2, 37.1, 40.8, 37.6,-33.3, 23.1, 18.3,-34.4
	+,-42.9, 37.1, 33.5,-12.0, 54.6, 48.5, 35.7, 78.2,-28.5, 49.6
	+, 68.0, 55.5,-54.5,-67.6, 19.1,-29.0, 26.3,-32.0, 50.0,-51.7
	+, 77.5, 18.5, 41.8,-77.9, 69.7, 45.4, 37.8, 52.2, 29.2,-19.7
	+, 56.5, 60.0, 66.5, 47.2, 61.6, 30.4, 47.6, 54.6, 67.4/
      DATA GLONS/
     +  23.6,254.7,116.3,152.9,149.1,358.7,150.7,106.4, 96.8,110.5
	+,172.8,  4.6,130.9,353.3,  0.5, 14.0, 26.5,113.4,109.3, 19.2
	+,147.2,127.5,126.5,283.1, 13.4,135.1,139.5, 15.9, 21.2,117.5
	+, 33.0, 37.3,159.0, 62.9,169.9,168.0,127.8,115.9, 14.6,302.2
	+,290.0,292.8, 12.5,166.8, 19.0,141.7,284.5, 21.1,129.6,146.9
	+, 84.9,151.0, 66.5, 39.7, 90.0,262.3,307.3, 83.2, 26.6/
	DATA CLATS/
     + -33.5,-55.4,-20.2, 40.4, 48.8,-53.4, 47.1, -9.5, 31.8, 86.2
	+, 48.7,-50.4, 30.6,-42.8,-43.7,-36.3, 34.0, -3.3,  0.6, 32.6
	+, 56.4,-18.1,-14.4, -8.0,-51.3,-30.2,-18.2,-67.2, 27.8,-29.8
	+,-56.9,-45.3, 62.8, 74.0, -9.0, 37.2, -7.4, 51.7,-47.0, 32.1
	+,-82.5,-38.3,-40.6, 72.9,-61.6,-28.1,-57.9,-46.9,-10.5, 34.5
	+,-37.5,-43.6,-49.4,-37.0,-42.2,-47.7,-68.6,-35.9,-57.9/
	DATA CLONS/
     +  37.7,240.3,114.7,163.3,162.6, 25.7,163.8,106.5, 95.1,124.3
	+,193.0, 29.1,134.3,  9.6, 18.7, 29.1, 13.1,112.9,109.0,  5.9
	+,165.0,124.2,123.8,283.2, 40.1,128.4,134.4, 75.8, 10.5,115.0
	+, 66.3, 58.5,189.8,  4.8,165.5,180.0,125.8,119.0, 37.4,298.2
	+,103.0,294.0, 30.2,250.1, 61.5,134.1,282.9, 44.1,127.1,153.8
	+, 92.1,136.0, 83.9, 55.6, 96.5,254.4,323.1, 90.4, 62.1/

CC
CC
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TTT(1:4)=TT(1:4)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT
c
	YEAR=DD(1:4)
	YY=YEAR(3:4)

	AMN=DD(5:6)
	read(amn,*) rmon
  	mn=int(rmon)

	DY2=DD(7:8)
	read(dy2,*) rdy2
	idy2=int(rdy2)
	idy1=idy2-1
C New month:
	if (idy2.eq.1) then
	mn=mn-1
	call blet2(mn,AMN)
	idy2=im(mn)
	call blet2(idy2,DY2)
	idy1=idy2
	endif
	call blet2(idy1,DY1)

C
C
C Prepare List of full data -stations
	APROX=2.876820E-02
	BPROX=4.601528
	nfulf=0
	nfulm=0
	do i=1,59
	fulf(i)='00'
	fulm(i)='00'
	enddo
	ii=0
	maxd2=0
	do 103 ist=1,59
	ii=ii+1
	nsub=2
	if (ist.eq.12) nsub=5	 !db
	if (ist.eq.51) nsub=1	 !tk
	if (ist.eq.56) nsub=6    !au
	if (ist.eq.57) nsub=6	 !sj
	if (ist.eq.58) nsub=3	 !ns
	if (ist.eq.59) nsub=4	 !so
	jf=1
	jh=1
	if (idy1.eq.1) then
	jt=1
	else
	jt=2
	endif
	STAT=STATS(IST)
      ST=STS(IST)
	glat=glats(ist)
	glon=glons(ist)
	xlat=clats(ist)
	xlon=clons(ist)
	write(*,299) NSUB,YEAR,AMN,DY1,DY2,GLAT,GLON,JF,JH,JT
	+,STAT,XLAT,XLON
  299	format(1X,I1,1X,A4,3(1X,A2),2(1X,F5.1),3(1X,I1),1X,A13,2(1X,F5.1))
  99	format(17X,I1,2(1X,F5.1),7X,A4,3(1X,A2),3(2X,I1)
     +,4X,A30)
	STNAME='                              '
	STATS(ii)=STAT
	STS(II)=ST
	NSUBS(II)=NSUB
	GLATS(II)=GLAT
	GLONS(II)=GLON
	YEARR(II)=YEAR
	AMNS(II)=AMN
	DY1S(II)=DY1
	DY2S(II)=DY2
	JFS(II)=JF
	JHS(II)=JH
	JTS(II)=JT
	STNAME(1:2)=YY
	STNAME(3:4)=AMN
	STNAME(5:6)=DY2
	STNAME(7:)=STAT
	do j=1,30
	if (STNAME(j:j).eq.'.') then
	jp=j
      STNAME(jp:)='_iono.txt'
	exit
	endif
	enddo
	STINP(II)=STNAME
	CLATS(II)=XLAT
	CLONS(II)=XLON
C
	if (jf.gt.0) then
	nfulf=nfulf+1
	fulf(nfulf)=st
	endif
C
	if (jh.gt.0) then
	nfulm=nfulm+1
	fulm(nfulm)=st
	endif
C
	if (ii.eq.1) then
      CALL SUBKPCA
	endif
  103	continue

	iinum=ii
CTemp	
C Start cycle on stations:
     	do 105 ist=1,II
	STAT=STATS(IST)
	ST=STS(IST)
	NSUB=NSUBS(IST)
	GLAT=GLATS(IST)
	GLON=GLONS(IST)
	YEAR=YEARR(IST)
	YY=YEAR(3:4)
	AMN=AMNS(IST)
	DY1=DY1S(IST)
	DY2=DY2S(IST)
	JF=JFS(IST)
	JH=JHS(IST)
	JT=JTS(IST)
	STTT=STATS(IST)
	STNAME=STINP(IST)
		write(*,*) stat,st

   38	WRITE(*,*)'year:',YEAR,' month:',amn,' day1:',dy1,' day2:',dy2
C
      YY=YEAR(3:4) 
	read(amn,*) rmon
 	mn=int(rmon)
	read(year,*) ryear
  	iyear=int(ryear)

	read(yy,*) yr
 	iyr=int(yr)
	read(dy1,*) d1
 	id1=int(d1)
	read(dy2,*) d2
  	id2=int(d2)
  159	z1=yr/4.
	  jz=int(z1)*4
	IF(jz.EQ.iyr) THEN
               IM(2)=29
        ELSE
                IM(2)=28
	       ENDIF
C Read R12 for current year:
	  open(19,file='R12.dat',status='OLD')
  211    read(19,*, end=199) j,(R12y(k),k=1,12)
         if (j.lt.iyear) then
	R12y(0)=R12y(12)
	   goto 211
	endif
         R12=R12y(mn)
      if (R12.gt.150.0) R12=150.0
  199 continue
      close(unit=19)
C
	IDNR=IM(MN)
	LHR=24*IDNR
		DD1='01' ! for input file title
C define day of end of month:
	jd=idnr
	call blet2(jd,DD2)
C
	 outfile1='d:\web\graf\temp\styrf.br'
	outfile1(18:19)=ST
	outfile1(20:21)=YY
	outfile1(22:25)='f.br'
C	
	outfile2=outfile1
	outfile2(22:25)='t.br'
		outfile3=outfile1
	outfile3(22:25)='m.br'
	outfile4=outfile3
	outfile4(22:25)='h.br'
	infile1='d:\web\graf\YEAR\styrf.br'
	infile1(13:16)=YEAR
	infile1(18:)=outfile1(18:)
	infile3=infile1
	infile3(18:)=outfile3(18:)
	infile4=infile1
	infile4(18:)=outfile4(18:)
C
C	
	select case (nsub)
C 
	case (1)
C TK:       
    1 continue
c	infile1='d:\web\graf\YEAR\styrf.br' 
	infile2=infile1
	infile2(10:10)='i'  ! data foF2 (TK) in /grif/2014/tk14f.br
   70	format(A128)
	open(11,file=infile1)
	open(12,file=infile2,action="READ")
	do i=1,62
	read(12,70,end=71) txt	   ! read data for Tomsk
	write(11,70) txt		   ! write data for Tomsk
	enddo
   71	close(unit=11)
	close(unit=12)
	goto 108    ! output results
C SEC:
	case (2)
    2 if (jt.eq.3) then
	 	if (DY1.eq.'01') then
 	jt=1
	               else
      jt=2
                 endif
	call subsec2(infile1,infile3,infile4)
	else
	goto 108
	endif
	goto 108      ! output results
C NS:
	case (3)
	call subionka2(if2,im3,ih2)           ! Novosibirsk
    3 continue
	 
	goto 108      ! output results
	case (4)
C SGO:
    4 continue
      call subsgo2(resf,resm)
	goto 108      

	case (5)
    5 continue	 
	call subxml1 ! Dourbes
	goto 108      ! output results
c
	case (6)
    6 continue	
      call subsao ! Austin, Sjj, Chinese (5)
	goto 108      ! output results


C+++++++
	end select 
C output results

  108	continue
C NEW++++ JT=2 means REMOVE the preceding day line from output files:
	  if (JF.GT.0) then
        fmh='f'
	  call subrecogs(fmh,outfile1)	  ! f.br
	endif
	  
	    if (JH.GT.0) then 
	fmh='m'
	  call subrecogs(fmh,outfile3)	  ! m3.br
	fmh='h'
	  call subrecogs(fmh,outfile4)	  ! hm.br
      endif
	fmh='t'
	  call subrecogs(fmh,outfile2)	  ! TEC
C+++++++++++++++++++++++++++++++++++++++++++++++
c
  702		JFS(IST)=JF
	JHS(IST)=JH
CREM       call subdevgx(IST)    ! DEVLOG
  102	continue
crem      write(*,98) STAT,ST,NSUB,GLAT,GLON,YEAR,AMN,DY1,DY2,JF,JH,JT
crem	+,STTT,STNAME
c	write(19,98) STAT,ST,NSUB,GLAT,GLON,YEAR,AMN,DY1,DY2,JF,JH,JT
c   98	format(1X,A13,A2,1X,I1,2(1X,F5.1),7X,A4,3(1X,A2)
c     +,1X,'f',I1,1X,'h',I1,1X,'t',I1,1X,A2,1X,A23)
c	pause' ' 
  105	continue
	
c	close(unit=19)

C +++++++++++++++Avoid filling gaps for COMPLETE data for given day
C
 1000	 continue
C	
C ++++++++++++ Prepare for c.p. calculations ++++++++++++
	DO 2001 ist=1,IINUM

	stat=stats(IST)
	 st=sts(IST)
	sttt=STATS(IST)
	year=yearr(IST)
	yy=year(3:4)
	amn=amns(IST)
	read(amn,*) mn
	dy11=dy1s(IST)
	dy22=dy2s(IST)
	read(dy11,*) d1  ! starting day for clone
  	id1=int(d1)
	read(dy22,*) d2	 ! ending day for clone
  	id2=int(d2)
C
c-	if (jfs(ist).eq.0) goto 2001
CREM	call subcongs(IST)      ! conj.point
 2001	continue
	pause ' '
	STOP
	END
c  
C***********************************************************
