	subroutine subhmax2(alati,along,xmagbr,idy,xf2,xm3,xhm)
C................................................................Oct.2013
C Use subinters.for
C ...............................................................Jan. 2012
C
C Produce hmF2 from xf2, xm3 for one day:
C xf2(0:23),xm3(0:23),xhf(0:23) ! daily sets for UT=0,...,23
C
c "TAB-hmF2 FROM foF2,foE,M3F2 FOR MONTH (31,24)
c
c THE MEAN COV-INDEX (3 SOLAR ROT.) IS EXPECTED
c DEN IS THE ELECTRON DENSITY IN M-3 H=HEIGHT, KM
c  LATI,LONG,DIP,NMF2,MAGBR,MLAT,MLONG,FOF2,HMF2,M3F2,FOE,RZ,COV
      DIMENSION HF2(31,0:23),IM(0:12)
	+,GLATS(59),GLONS(59),JFS(59),JHS(59),JTS(59)
	+,rzar(3),arig(3)
	+,xf2(0:23),xm3(0:23),xhm(0:23) ! daily sets for UT=0,...,23
	 INTEGER*2 ID1,ID2
	+,iyri,idyi
	CHARACTER*2	sta,ayr,amn,dy1,dy2,DD1,DD2,YY
	+,STS(59),AMNS(59),DY22,ADY,AUT
	CHARACTER*4	YEAR,TT
	CHARACTER*13 STATS(59),STAT
	CHARACTER*1 hhh
		CHARACTER(10) DD
      CHARACTER(5) ZZ
	integer*2 iyr,imn,idy,jut
	COMMON   /CONST/UMR
      COMMON /BL1/STA,YEAR,YY,AMN,DY1,DY2,DD1,DD2,ID1,ID2,JF,JH,JT,DY22
	COMMON /BL2/ STAT,GLAT,GLON,DD,TT,ZZ,DIP
	COMMON /BL3/ STATS,STS,GLATS,GLONS,JFS,JHS,II,AMNS,JTS
      DATA IM/31,31,28,31,30,31,30,31,31,30,31,30,31/

	      UMR=.0174533
      PHI=3.141593
	call blet2(idy,ADY)
C
	do i=1,31
	do k=0,23
	hf2(i,k)=0.
	enddo
	enddo
c Test
	read(year,*) ryear
	iyear=int(ryear)
      ayr=year(3:4)
	read(ayr,*) yr
	iyr=int(yr)
	read(amn,*) rmn
	mn=int(rmn)

	IF(mn.EQ.0) GOTO 2

c 1110	write (*,*) 'Enter DY1,DY2:'
c	read (*,1109) DY1,DY2
c 1109 format(A2)     
c==      read(dy1,*) rdy1
c==	read(dy2,*) rdy2
c==	idy1=int(rdy1)
c==	idy2=int(rdy2)

c==	     outfile1='d:\web\idce\styrh.br'
c==	outfile1(13:14)=sta
C ===========================================
C++ 
C Add extract Rzs from ig_rz.dat file
	imn=mn
	iyri=iyr
	idyi=15
	ldai=ndoy(iyri,imn,idyi)
	call tcon(iyear,mn,15,ldai,rzar,arig,ttt,nmonth)
	rz=rzar(3)        
 	COV=63.75+RZ*(0.728+RZ*0.00089) ! COV index F10.7

	IF(IYR.LT.90) THEN
         IYYYY=2000+IYR
      ELSE
         IYYYY=1900+IYR
      ENDIF
      IF (YR/4.eq.INT(YR/4)) THEN
 	 IM(2)=29 
	      IDNR=366
	 ELSE 
	 IM(2)=28
	      IDNR=365
	endif

	ABSLAT=ABS(ALATI)
C
crem	numd=idy2-idy1+1       ! number of days for hmF2 calculations
		numd=1


C ++++++++++++++++++ Input of foF2 cloned data and M3000 data:++++++++++++++++++++++
	ihflag=0
	goto 119
  118	continue  ! no data h-input
	goto 117
C
  119	continue 

  117	continue
	jd=idy ! one given day
CC CALCULATION OF DAY OF YEAR	(LDA)
	      mosum=0
      if(mn.gt.1) then
         do 1234 i=1,mn-1
1234   mosum=mosum+im(i)
         endif
      lda=mosum+jd          ! daynr

C !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 	do 1111 jut=0,23               ! start cycle on UT 
	fof2=xf2(jut)
	xm3000=xm3(jut)
	if (xhm(jut).gt.0.) goto 1111
	if ((xm3000.lt.2.).or.(fof2.eq.0.)) then
	hhh='h'
	call blet2(jut,aut)
CREM	call subinterj(hhh,ayr,amn,ady,aut,resm)
	call subinters(hhh,ayr,amn,ady,aut,resm)
	xhm(jut)=resm
	goto 1111
	endif
	hour=float(jut)+along/15.0           ! Local time
	if (hour.ge.24.) hour=hour-24.

	CALL SOCO(LDA,HOUR,ALATI,ALONG,SUNDEC,XHI,SAX,SUX)
 	CALL SOCO(LDA,12.0,ALATI,ALONG,SUNDE1,XHINON,SAXNON,SUXNON)

	FOE=FOEEDI(COV,XHI,XHINON,ABSLAT)
c
crem	fof2=fof(jj,jut)
crem	xm3000=rm3(jj,jut)
		fof2=xf2(jut)
		xm3000=xm3(jut)
C++
	HMF2=HMF2ED(XMAGBR,RZ,FOF2/FOE,XM3000)
 1112	if (hmf2.lt.170.) then
 	hmf2=hmf2+10.
	goto 1112
           endif
	if (hmf2.gt.600.) then
	hmf2=0.
	endif
c 350	hmf(jj,jut)=hmf2
 350	xhm(jut)=hmf2
	if (xhm(jut).gt.900.) then
Crem	call subinterj(hhh,ayr,amn,ady,aut,resm)
	call subinters(hhh,ayr,amn,ady,aut,resm)
	xhm(jut)=resm
	endif
c==	ihmf(jj,jut)=nint(hmf2)
 1111	continue          ! end UT-cycle


    2	continue
c==      write(*,*) sta
C      pause ' '
      
      return
      END
C=================================================================
	      REAL FUNCTION HMF2ED(XMAGBR,R,X,XM3)         
C CALCULATES THE PEAK HEIGHT HMF2/KM FOR THE MAGNETIC                           
C LATITUDE XMAGBR/DEG. AND THE SMOOTHED ZUERICH SUNSPOT                         
C NUMBER R USING CCIR-M3000 XM3 AND THE RATIO X=FOF2/FOE.                       
C [REF. D.BILITZA ET AL., TELECOMM.J., 46, 549-553, 1979]                       
C D.BILITZA,1980.     
      F1=(2.32E-3)*R+0.222                         
      F2=1.2-(1.16E-2)*EXP((2.39E-2)*R)            
      F3=0.096*(R-25.0)/150.0                      
      DELM=F1*(1.0-R/150.0*EXP(-XMAGBR*XMAGBR/1600.0))/(X-F2)+F3                
      HMF2ED=1490.0/(XM3+DELM)-176.0               
      RETURN          
      END             
c--------------------------------------------------------------------
C ------------------------------------------------------
      REAL FUNCTION FOEEDI(COV,XHI,XHIM,XLATI)
C-------------------------------------------------------
C CALCULATES FOE/MHZ BY THE EDINBURGH-METHOD.      
C INPUT: MEAN 10.7CM SOLAR RADIO FLUX (COV), GEOGRAPHIC
C LATITUDE (XLATI/DEG), SOLAR ZENITH ANGLE (XHI/DEG AND 
C XHIM/DEG AT NOON).
C REFERENCE: 
C 	KOURIS-MUGGELETON, CCIR DOC. 6/3/07, 1973
C 	TROST, J. GEOPHYS. RES. 84, 2736, 1979 (was used
C		to improve the nighttime varition)
C D.BILITZA--------------------------------- AUGUST 1986.    
      COMMON/CONST/UMR
C variation with solar activity (factor A) ...............
      A=1.0+0.0094*(COV-66.0)                      
C variation with noon solar zenith angle (B) and with latitude (C)
      SL=COS(XLATI*UMR)
	IF(XLATI.LT.32.0) THEN
		SM=-1.93+1.92*SL                             
		C=23.0+116.0*SL                              
 	ELSE
	 	SM=0.11-0.49*SL                              
	 	C=92.0+35.0*SL  
  	ENDIF
	if(XHIM.ge.90.) XHIM=89.999
	B = COS(XHIM*UMR) ** SM
C variation with solar zenith angle (D) ..........................        
 	IF(XLATI.GT.12.0) THEN
		SP=1.2
	ELSE
		SP=1.31         
	ENDIF
C adjusted solar zenith angle during nighttime (XHIC) .............
      XHIC=XHI-3.*ALOG(1.+EXP((XHI-89.98)/3.))   
      D=COS(XHIC*UMR)**SP       
C determine foE**4 ................................................
      R4FOE=A*B*C*D     
C minimum allowable foE (sqrt[SMIN])...............................
      SMIN=0.121+0.0015*(COV-60.)
      SMIN=SMIN*SMIN
      IF(R4FOE.LT.SMIN) R4FOE=SMIN                     
      FOEEDI=R4FOE**0.25                           
      RETURN          
      END   
c
      subroutine tcon(yr,mm,day,idn,rz,ig,rsn,nmonth)
c----------------------------------------------------------------
c input:        yr,mm,day       year(yyyy),month(mm),day(dd)
c               idn             day of year(ddd)
c output:       rz(3)           12-month-smoothed solar sunspot number
c               ig(3)           12-month-smoothed IG index
c               rsn             interpolation parameter
c               nmonth          previous or following month depending
c                               on day
c
c rz(1), ig(1) contain the indices for the month mm and rz(2), ig(2)
c for the previous month (if day less than 15) or for the following
c month (otherwise). These indices are for the mid of the month. The
c indices for the given day are obtained by linear interpolation and
c are stored in rz(3) and ig(3).
c
c the indices are obtained from the indices file ig_rz.dat that is 
c read in subroutine initialize and stored in COMMON/indices/
c----------------------------------------------------------------
      integer      yr, mm, day, iflag, iyst, iyend,iymst
      integer      imst,iymend
      real         ionoindx(772),indrz(772)
      real         ig(3),rz(3)
      save         ionoindx,indrz,iflag,iyst,iymst,
     &         iymend,imst
c
c Rz12 and IG are determined from the file IG_RZ.DAT which has the
c following structure: 
c day, month, year of the last update of this file,
c start month, start year, end month, end year,
c the 12 IG indices (13-months running mean) for the first year, 
c the 12 IG indices for the second year and so on until the end year,
c the 12 Rz indices (13-months running mean) for the first year,
c the 12 Rz indices for the second year and so on until the end year.
c The inteporlation procedure also requires the IG and Rz values for
c the month preceeding the start month and the IG and Rz values for the
c month following the end month. These values are also included in 
c IG_RZ.
c 
c A negative Rz index means that the given index is the 13-months-
C running mean of the solar radio flux (F10.7). The close correlation 
C between (Rz)12 and (F10.7)12 is used to derive the (Rz)12 indices.
c
c An IG index of -111 indicates that no IG values are available for the
c time period. In this case a correlation function between (IG)12 and 
C (Rz)12 is used to obtain (IG)12.
c
c The computation of the 13-month-running mean for month M requires the
c indices for the six months preceeding M and the six months following 
C M (month: M-6, ..., M+6). To calculate the current running mean one 
C therefore requires predictions of the indix for the next six months. 
C Starting from six months before the UPDATE DATE (listed at the top of 
c the file) and onward the indices are therefore based on indices 
c predictions.
      if(iflag.eq.0) then
      open(unit=12,file='ig_rz.dat',ERR=10,status='old')
c-web- special for web version
c          open(unit=12,file=
c     *'/usr/local/etc/httpd/cgi-bin/models/IRI/ig_rz.dat',
c     *status='old')
		GOTO 20
   10 PAUSE ' CANNOT FIND THE FILE "IG_RZ.DAT". EXECUTION TEMINATED.'
      STOP
   20 CONTINUE	 
c Read the update date, the start date and the end date (mm,yyyy), and
c get number of data points to read.
          read(12,*) iupd,iupm,iupy
          read(12,*) imst,iyst, imend, iyend
          iymst=iyst*100+imst
          iymend=iyend*100+imend
c inum_vals= 12-imst+1+(iyend-iyst-1)*12 +imend + 2
c            1st year \ full years       \last y\ before & after
          inum_vals= 3-imst+(iyend-iyst)*12 +imend
c Read all the ionoindx and indrz values
          read(12,*) (ionoindx(i),i=1,inum_vals)
          read(12,*) (indrz(i),i=1,inum_vals)
          do 1 jj=1,inum_vals
                rrr=indrz(jj)
                if(rrr.lt.0.0) then
                        covr=abs(rrr)
                        rrr=33.52*sqrt(covr+85.12)-408.99
                        if(rrr.lt.0.0) rrr=0.0
                        indrz(jj)=rrr
                        endif
                if(ionoindx(jj).gt.-90.) goto 1
                  zi=-12.349154+(1.4683266-2.67690893e-03*rrr)*rrr
                  if(zi.gt.274.0) zi=274.0
                  ionoindx(jj)=zi
1               continue
          close(unit=12)
          iflag = 1
        endif

        iytmp=yr*100+mm
        if (iytmp .lt. iymst .or. iytmp .gt. iymend) then
               if(konsol.gt.1) write(konsol,8000) iytmp,iymst,
     &                                            iymend
 8000          format(1x,I10,'** OUT OF RANGE **'/,5x,
     &  'The file IG_RZ.DAT which contains the indices Rz12',
     &  ' and IG12'/5x,'currently only covers the time period',
     &  ' (yymm) : ',I6,'-',I6)
               nmonth=-1
               return
               endif

c       num=12-imst+1+(yr-iyst-1)*12+mm+1
        num=2-imst+(yr-iyst)*12+mm

        rz(1)=indrz(num)
        ig(1)=ionoindx(num)
        midm=15
        if(mm.eq.2) midm=14
        call MODA(0,yr,mm,midm,idd1,nrdaym)
        if(day.lt.midm) goto 1926
                imm2=mm+1
                if(imm2.gt.12) then
                        imm2=1
                        iyy2=yr+1
                        idd2=380
c               if((yr/4*4.eq.yr).and.(yr/100*100.ne.yr)) idd2=381
                        if(yr/4*4.eq.yr) idd2=381

                        if(yr/4*4.eq.yr) idd2=381
                else
                        iyy2=yr
                        midm=15
                        if(imm2.eq.2) midm=14
                        call MODA(0,iyy2,imm2,midm,IDD2,nrdaym)
                endif
                rz(2)=indrz(num+1)
                ig(2)=ionoindx(num+1)
                rsn=(idn-idd1)*1./(idd2-idd1)
                rz(3)=rz(1)+(rz(2)-rz(1))*rsn
                ig(3)=ig(1)+(ig(2)-ig(1))*rsn
                goto 1927
1926            imm2=mm-1
                if(imm2.lt.1) then
                        imm2=12
                        idd2=-16
                        iyy2=yr-1
                else
                        iyy2=yr
                        midm=15
                        if(imm2.eq.2) midm=14
                        call MODA(0,iyy2,imm2,midm,IDD2,nrdaym)
                endif
                rz(2)=indrz(num-1)
                ig(2)=ionoindx(num-1)
                rsn=(idn-idd2)*1./(idd1-idd2)
                rz(3)=rz(2)+(rz(1)-rz(2))*rsn
                ig(3)=ig(2)+(ig(1)-ig(2))*rsn

1927    nmonth=imm2
            return
            end
c
C ===============================================================
C
      SUBROUTINE MODA(IN,IYEAR,MONTH,IDAY,IDOY,NRDAYMO)
C-------------------------------------------------------------------
C CALCULATES DAY OF YEAR (IDOY, ddd) FROM YEAR (IYEAR, yy or yyyy),
C MONTH (MONTH, mm) AND DAY OF MONTH (IDAY, dd) IF IN=0, OR MONTH
C AND DAY FROM YEAR AND DAY OF YEAR IF IN=1. NRDAYMO is an output
C parameter providing the number of days in the specific month.
C-------------------------------------------------------------------
      DIMENSION       MM(12)
      DATA            MM/31,28,31,30,31,30,31,31,30,31,30,31/

      IMO=0
      MOBE=0

      if((iyear/4*4.eq.iyear).and.(iyear/100*100.ne.iyear)) mm(2)=29

      IF(IN.GT.0) GOTO 5
      mosum=0
      if(month.gt.1) then
         do 1234 i=1,month-1
1234                            mosum=mosum+mm(i)
         endif
      idoy=mosum+iday
      nrdaymo=mm(month)
      RETURN

5       IMO=IMO+1
      IF(IMO.GT.12) GOTO 55
      MOOLD=MOBE
      nrdaymo=mm(imo)
      MOBE=MOBE+nrdaymo
      IF(MOBE.LT.IDOY) GOTO 5
55              MONTH=IMO
      IDAY=IDOY-MOOLD
      RETURN
      END
c
Cc ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++==
