      subroutine subinters(fm,syr,smn,sdy,sut,res)
C.........................................................Oct. 2013
C Use fcF2 & hcF2 results of MAPIRIP
C
C.................................................................Nov. 2012
C JPL maps
C.................................................................Dec. 2011
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Use fc,hc,tc interpolated from directories dfc, dhc, dtc maps
C
	DIMENSION fhdat(0:72,71)	  ! maps fcF2,hcF2,TEC
	CHARACTER*13 STAT,txt
	CHARACTER*1 fm
	CHARACTER*2 syr,smn,sdy,sut,cyr,cmn,cdy
	CHARACTER(10) DDDD
	CHARACTER*4 TIMC 
	CHARACTER(5) ZZZ
      CHARACTER*40 infilef
            COMMON /BL2/ STAT,GLAT,GLON,DDDD,TIMC,ZZZ,R12

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Use fc,hc predictions from directories dfc, dhs
cold	  call subsimfh(isp,jdy,nut,fres,hres)	! model simulation
c---	fres=0.
c---	hres=0.
C NEW ========================================================
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		CYR=DDDD(3:4)
	read(cyr,*) ryr
	iyr=int(ryr)
 	 CMN=DDDD(5:6)
	read(cmn,*) rmn
	imn=int(rmn)
	CDY=DDDD(7:8)
	read(cdy,*) rdy2
	 ndy2=int(rdy2)  ! current day
	read(sdy,*) rdy1
	 ndy1=int(rdy1)	  ! input day
	read(smn,*) rmn1
	imn=int(rmn)
	imn1=int(rmn1)
	lda1=ndoy(iyr,imn1,ndy1)
	lda2=ndoy(iyr,imn,ndy2)

C Use fc,hc predictions from directories dfc or dhc
	infilef='d:\web\dfs\YR\MN\fcMNDYUT.jYR'
c//      infilef='d:\web\graf\dfc\YR\MN\ut\fcMNDYUT.jYR' !++
	infilef(12:13)=SYR							 !++
	infilef(15:16)=SMN							 !++
	infilef(28:29)=SYR							 !++
	infilef(20:21)=SMN							 !++
      infilef(9:9)=fm		   ! f or h or t	 !++
	infilef(18:18)=fm	   ! f or h	or t		 !++
	infilef(19:19)='c'							 !++
	infilef(22:23)=sdy							 !++
	infilef(24:25)=sut
C check availability of 'c' file
	OPEN(10,FILE=INFILEF)		! 'c'
	read(10,*,err=301,end=302) txt
	if (txt(1:1).eq.'') then
	goto 302
	else
	close (unit=10)
	goto 310
	endif
  302		infilef(19:19)='a' 						 !++
 	close(unit=10)
	goto 303
  301	write(*,*) 'Error reading file ',infilef
	pause ' '
	goto 302
  303		OPEN(10,FILE=INFILEF)		! 'a'
 	read(10,*,err=304,end=305) txt
	if (txt(1:1).eq.'') then 
	goto 305
	else
	close (unit=10)
	goto 310
	endif
  305		infilef(19:19)='b' 						 !++
 	 close(unit=10)
	goto 310
  304	write(*,*) 'Error reading file ',infilef
 	pause ' '
	goto 305

 204	format(73(1X,F4.0))
 310	OPEN(10,FILE=INFILEF)		!
 	read(10,*,err=307,end=307) txt
	if (txt(1:1).eq.'') then 
	goto 307
	else
	backspace(10)
	goto 311
	endif
  307	write(*,*) 'Error reading file ',infilef
 	pause ' '
	STOP

 311		do ilat=1,71
	read(10,204) (fhdat(k,ilat),k=0,72)	
	enddo
	close(unit=10)
C
C      interpolate for glat,glon
C Linear Interpolation for TEC(amlat,amlon)  
	aglat=-90.
	do 161 ilat=1,70 ! select pair of lats-lines (k) & (k+1)
c	aglat=-87.5,-85,...,87.5
	aglat=-90.+2.5*ilat
	aglat2=aglat+2.5
C
	if ((glat.gt.aglat).and.(glat.le.aglat2)) then  !   <<<<1
C Select pair of longs embracing glong(MLT)
	 clon=-185.
	along=glon
	if (along.ge.180.) along=along-360.
	do j=0,71 ! select pair of longs (j) & (j+1)
	clon=clon+5.
	clon2=clon+5.
	if ((along.ge.clon).and.(along.lt.clon2)) then  ! +++2
	res11=fhdat(j,ilat)
	res12=fhdat(j+1,ilat)
	res21=fhdat(j,ilat+1)
	res22=fhdat(j+1,ilat+1)
	res1=res11+(res12-res11)/5.*(along-clon)
	res2=res21+(res22-res21)/5.*(along-clon)
	res=res1+(res2-res1)/2.5*(glat-aglat)
	endif											 ! +++2
	enddo	! end select pair of longs (j) & (j+1)
	exit
	endif											 !   <<<<1
  161 continue		   ! interpolation end
	RETURN
	END