C ========================================================
C 
      SUBROUTINE SUBRECONS(fmh,outgap)
C...............................................Oct. 2013
C Use subinterps.for
C.............................................Jan. 2012
C Based on subremov.for subroutine
C
C Include here reconstruction of missed data from relevant map
C
C----------------------------------------------------------------
C
C program for producing 2-mns  xxx.br OUTPUT web files foF2, M3000F2 and hmF2
C
C*********TEST
C 
	DIMENSION XDAT(0:23),IRES(0:23)
     +,if2(31,0:23),ih2(31,0:23),im3(31,0:23)
	+,xf2(0:23),xm3(0:23),xhm(0:23)
      CHARACTER*128  OUTGAP,ZZZ(70),XXX,INFILE1,INFILE2,YYY(70)
	+,XEND
c//     +,HEADER(4)
c     +,TXT
	CHARACTER*2 ST,AMN,DY1,DY2,dd1,dd2,DY22,YY,DMN,PM,PY,XMN,XDY,XYR
	+,PD,SDY,SS(0:23),AUT,AYR
     +,CMN,CDY
     	CHARACTER*4 YEAR,TITS(4),TITPAR,TTT
	+,CYEAR,CTIME
	CHARACTER*30 STNAME
	CHARACTER*13 STAT
	CHARACTER(10) DD
      CHARACTER(5) ZZ,YYYYY,YDAT(0:23)
	CHARACTER*3	VVV
	CHARACTER*1 fmh,f1
	INTEGER*2 ID1,ID2,idy,nday,iut,ipy,ipm
C
	COMMON /BL1/ST,YEAR,AYR,AMN,DY1,DY2,DD1,DD2,ID1,ID2,JF,JH,JT,DY22
	+,STNAME
	COMMON /BL2/ STAT,GLAT,GLON,DD,TTT,ZZ,DIP
	COMMON /BL8/ IF2,IM3,IH2
	DATA TITS/'foF2','M3F2','hmF2','TEC '/
C
 	 cyear=DD(1:4)
 	 cmn=DD(5:6)
	cdy=DD(7:8)			 
	ctime=TTT
	ctime(3:4)='UT'

C First create .br file for prec. month PM (prec. year PY) + current month AMN (current year YY)
	read(ayr,*) ryr
	iyr=int(ryr)
	read(amn,*) rmn
	imn=int(rmn)
	read(DY1,*) rdy
	idy1=int(rdy)
	read(DY2,*) rdy2
	idy2=int(rdy2)

c--	idy=idy1-1  ! last preceding day
	idy=idy1
	call blet2(idy,PD)
	 ipm=imn-1
	ipy=iyr
C for current JAN
	if (imn.eq.1) then
	ipy=ipy-1
	ipm=12
	endif
C
	call blet2(ipy,PY)
	call blet2(ipm,PM)
	if (imn.eq.1) then
	DMN='00'
	else
	DMN=PM
	endif
C+++++++++++++
C
	infile1='d:/web/dat1/yy/STYYPMf.txt'

	infile1(16:17)=ST
	if (fmh.eq.'f') then
	infile1(11:11)='1'
	infile1(22:)='.txt'
	TITPAR=TITS(1)
	endif
	if (fmh.eq.'m') then
	infile1(11:11)='5'
	infile1(22:)='m.txt'
	TITPAR=TITS(2)
	endif
	if (fmh.eq.'h') then
	infile1(11:11)='6'
	infile1(22:)='h.txt'
	TITPAR=TITS(3)
	endif
	if (fmh.eq.'t') then
	infile1(11:11)='7'
	infile1(22:)='t.txt'
	TITPAR=TITS(4)
	endif
	infile2=infile1     ! for current month
	infile1(13:14)=PY
	infile1(18:19)=PY
	infile1(20:21)=PM

	infile2(13:14)=AYR
	infile2(18:19)=AYR
	infile2(20:21)=AMN
C
C Avoid input of prec. month for
C
	j1=0  ! 
	OPEN(22,FILE=OUTGAP,action='write') ! foF2
crem 	if (fmh.eq.'t') goto 199
C
C input of prec. month :
C
  200		OPEN(20,FILE=infile1)
      jcnt=0
      do 141 j=1,41
  198	READ (20,17,END=195,ERR=211) XXX
	if (j.lt.5) goto 141  ! avoid 4 extra lines
	XXX(1:2)=PY
	XXX(3:4)=PM
c	if (imn.eq.1) then
c	XXX(3:4)=DMN
c	ENDIF
      ZZZ(j-4)=XXX
c-	write(*,17) XXX
  	jcnt=jcnt+1
 141	continue
 195	close(unit=20)

   17	format(A128)
  117	FORMAT(A13,1X,A4)
 118	FORMAT('Date of issue: ',A4,'.',A2,'.',A2,1X,'Time:',A4)
  201	format('YYMMDD|UT 0    1    2    3    4    5    6    7    8'
    	&'    9   10   11   12   13   14   15   16   17   18   19   20'
	&'   21   22   23'/'-------------------------------------------'
     &'-------------------------------------------------------------'
     &'------------------------')

C Correct OUTGAP:
	do j=1,jcnt  !  prec. month
	write(*,17) ZZZ(j)  ! temp
	write(22,17) ZZZ(j)
	enddo
	j1=jcnt ! last prec. month record
C
C Current month:
 199	continue
c
      OPEN(21,FILE=infile2) !	 reading INFILE2
	jcnt=0
	 do 142 j=1,41
  	READ (21,17,END=196,ERR=212) XXX

	if (j.lt.5) then 
c//	HEADER(j)=XXX
	goto 142  ! avoid 4 extra lines
	endif
	XYR=XXX(1:2)
	XMN=XXX(3:4)
	XDY=XXX(5:6)
	if ((xyr.eq.AYR).and.(xmn.eq.AMN).and.(xdy.eq.PD)) goto 196 ! till prec.day
	j1=j1+1
	YYY(j-4)=XXX
	  	jcnt=jcnt+1
 142	continue
 196	close(unit=21)
	jend=jcnt
	XEND=XXX
C++
 
      OPEN(23,FILE=infile2)  ! write here results: for DY1...DY2 
c--      if (DY1.eq.'01') then
	write(*,117) stat,TITPAR 
c//	WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT
	write(*,118) CYEAR,CMN,CDY,CTIME
	write(*,201)
c//	write(*,17) HEADER(3)
c//	write(*,17) HEADER(4)
	write(23,117) stat,TITPAR 
c//	WRITE(23,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT
	write(23,118) CYEAR,CMN,CDY,CTIME
	write(23,201)
c//	write(23,17) HEADER(3)
c//	write(23,17) HEADER(4)
c--	goto 300  ! to read/reconstruct/write new line(s)
c--	endif
C++
		do j=1,jend
	XXX=YYY(j)
	XMN=XXX(3:4)
	XDY=XXX(5:6)
	if ((xmn.eq.amn).and.(xdy.eq.dy1)) then 
	goto 207
	else
	write(*,17) YYY(j)
	write(22,17) YYY(j)
 	write(23,17) YYY(j)
	endif
	enddo
 207	continue
crem      close(unit=23)
C
C Add new data from DY1 to DY2
C
  317 FORMAT(3I2,2X,24(A5))
  300	CONTINUE
	infile1='d:/web/graf/20YR/STYYf.br'
	infile1(15:16)=AYR
	infile1(18:19)=ST
	infile1(20:21)=AYR
	infile1(22:22)=fmh
c==	if (fmh.eq.'t') goto 304  !
	OPEN(11,FILE=infile1)
C
crem	do 301 nday=idy1,idy2
  304	nday=idy1-1
  303	nday=nday+1
	if (nday.gt.idy2) goto 302 ! end reading new data
C new data:
	call blet2(nday,SDY)
	do k=0,23
	ydat(k)='000  '
	xhm(k)=0.
	enddo
	if (fmh.eq.'t') goto 305  !
C
  306	READ (11,317,END=305,ERR=211) JY,JM,JD,(ydat(k),k=0,23)
	if ((jy.eq.iyr).and.(jm.eq.imn).and.(jd.eq.nday)) then 
	goto 305
	else
	goto 306
	endif
C
C Reconstruction of missed data
C
  305	continue
	iflag=0
	do 301 iut=0,23		  ! Cycle on UT	=====================
	YYYYY=ydat(iut)
	VVV=YYYYY(1:3)
	YY=YYYYY(4:5)
	if (YY(1:1).eq.'/') then
	VVV='000'
	YY='  '
	endif
	SS(iut)=YY
	if (vvv(1:1).eq.' ') vvv(1:1)='0'
	if (vvv(2:2).eq.' ') vvv(2:2)='0'
	if (vvv(3:3).eq.' ') vvv(3:3)='0'
	read(vvv,*) rrr
	xdat(iut)=rrr
	if (fmh.eq.'m') goto 301 ! avoid M3000 reconstruction
C 
C Reconstruction from map:
          	if (rrr.eq.0.) then
	if((fmh.eq.'h').and.(if2(nday,iut).gt.0).and.(im3(nday,iut).gt.0))
	+ goto 327
		call blet2(iut,AUT)
C
  	f1=fmh
c 	call subinterj(f1,ayr,amn,sdy,aut,resm)
 	call subinters(f1,ayr,amn,sdy,aut,resm)
	xdat(iut)=resm
	yy(1:1)='/'
	if (fmh.ne.'t') SS(iut)=YY
	       endif
C
  327	if (fmh.eq.'h') then
C Check if hmF2 can be produced from foF2 & M3000 F2
	   if ((if2(nday,iut).gt.0).and.(im3(nday,iut).gt.0)) then 
 	iflag=1
	xdat(iut)=0.
	yy(1:1)=' '
	endif
	endif
  301	continue  ! End cycle on UT
	if ((fmh.eq.'h').and.(iflag.gt.0)) then  !++++++++++++++
C Produce hmF2 from M3000P
	do iut=0,23
	xf2(iut)=float(if2(nday,iut))/10.
	xm3(iut)=float(im3(nday,iut))/100.
c	xhm(iut)=float(ih2(nday,iut))
	xhm(iut)=xdat(iut)
	enddo
		xlat=glat
 	xlon=glon
	xdip=dip
	call subhmax2(xlat,xlon,xdip,nday,xf2,xm3,xhm)
		glat=xlat
	glon=xlon
	dip=xdip
	do k=0,23
	xdat(k)=xhm(k)
crem	yy(1:1)=' '
	enddo
	endif								   !++++++++++++++++++
C
  310	format(3A2,2X,24(I3,A2))
  311	format(3A2,1X,24(I4,1X))
C Record results for the day:
  335 	do kk=0,23
	ires(kk)=nint(xdat(kk))
	if (fmh.eq.'f') if2(nday,kk)=ires(kk)
	if (fmh.eq.'m') im3(nday,kk)=ires(kk)
	if (fmh.eq.'h') ih2(nday,kk)=ires(kk)
	enddo
	if (fmh.eq.'t') then
	write(*,311) ayr,amn,sdy,(ires(k),k=0,23)
	write(22,311) ayr,amn,sdy,(ires(k),k=0,23)
	write(23,311) ayr,amn,sdy,(ires(k),k=0,23)
	else
	write(*,310) ayr,amn,sdy,(ires(k),ss(k),k=0,23)
	write(22,310) ayr,amn,sdy,(ires(k),ss(k),k=0,23)
	write(23,310) ayr,amn,sdy,(ires(k),ss(k),k=0,23)
	endif
	GOTO 303	  ! next day
c== 302	if (fmh.ne.'t') close(unit=11)
  302	 close(unit=11)
      goto 210
C
 211  write(*,*) 'No input datafile:',infile1
      pause ' '
	goto 210
 212	write(*,*) 'No input datafile:',infile2
      pause ' '
 210	CONTINUE
	close(unit=22)
	close(unit=23)
C	
	write(*,331) stat
  331	format(1X,A13)
crem		pause ' '
      RETURN
       END
